
import java.awt.AWTEvent;
import java.awt.Button;
import java.awt.Color;
import java.awt.Dialog;
import java.awt.Dimension;
import java.awt.FlowLayout;
import java.awt.Frame;
import java.awt.GridLayout;
import java.awt.Label;
import java.awt.Panel;
import java.awt.Point;
import java.awt.event.ActionEvent;
import java.awt.event.WindowEvent;

/** Dialog to communicate a message in a popup window, and wait for a response. */
public class CancelOkDialog extends Dialog {

	Panel dialogPanel = new Panel();

	Panel buttonPanel = new Panel();

	Label messageLine1 = new Label();

	Label messageLine3 = new Label();

	Label messageLine2 = new Label();

	Button leftButton = new Button();

	Button rightButton = new Button();

	GridLayout gridLayout1 = new GridLayout(0, 1);

	FlowLayout flowLayout1 = new FlowLayout();

	public CancelOkDialog(Frame frame, String title, boolean modal) {
		super(frame, title, modal);
		enableEvents(AWTEvent.WINDOW_EVENT_MASK);
		try {
			jbInit();
			add(dialogPanel);
			pack();
			Point upperLeftCorner = frame.getLocation();
			Dimension parentSize = frame.getSize();
			Dimension dialogSize = this.getSize();
			upperLeftCorner.translate(
				(parentSize.width - dialogSize.width) / 2,
				(parentSize.height - dialogSize.height) / 2);
			this.setLocation(upperLeftCorner);
		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}

	public CancelOkDialog(Frame frame, String line1, String line2,
			String line3, String leftButtonText, String rightButtonText) { 
		// Three-line message and two buttons.
		super(frame, "", true);
		messageLine1.setText(line1);
		messageLine2.setText(line2);
		messageLine3.setText(line3);
		leftButton.setLabel(leftButtonText);
		rightButton.setLabel(rightButtonText);
		enableEvents(AWTEvent.WINDOW_EVENT_MASK);
		try {
			jbInit();
			add(dialogPanel);
			pack();
		} catch (Exception ex) {
			ex.printStackTrace();
		}
		Point upperLeftCorner = frame.getLocation();
		Dimension parentSize = frame.getSize();
		Dimension dialogSize = this.getSize();
		upperLeftCorner.translate((parentSize.width - dialogSize.width) / 2,
			(parentSize.height - dialogSize.height) / 2);
		this.setLocation(upperLeftCorner);
	}

	public CancelOkDialog(Frame frame, String line1, String line2, String line3) {
		// OK dialog.
		super(frame, "", true);
		messageLine1.setText(line1);
		messageLine2.setText(line2);
		messageLine3.setText(line3);
		leftButton.setVisible(false);
		rightButton.setLabel(Ethno.interfaceTexts.getString("okText"));
		enableEvents(AWTEvent.WINDOW_EVENT_MASK);
		try {
			jbInit();
			add(dialogPanel);
			pack();
		} catch (Exception ex) {
			ex.printStackTrace();
		}
		Point upperLeftCorner = frame.getLocation();
		Dimension parentSize = frame.getSize();
		Dimension dialogSize = this.getSize();
		upperLeftCorner.translate((parentSize.width - dialogSize.width) / 2,
			(parentSize.height - dialogSize.height) / 2);
		this.setLocation(upperLeftCorner);
	}

	void jbInit() throws Exception {
		dialogPanel.setLayout(gridLayout1);
		buttonPanel.setLayout(flowLayout1);
		flowLayout1.setHgap(25);
		messageLine1.setAlignment(1);
		messageLine2.setAlignment(1);
		messageLine3.setAlignment(1);
		dialogPanel.setBackground(Color.pink);
		buttonPanel.setBackground(Color.pink);
		messageLine1.setBackground(Color.pink);
		messageLine2.setBackground(Color.pink);
		messageLine3.setBackground(Color.pink);
		dialogPanel.add(messageLine1, null);
		dialogPanel.add(messageLine2, null);
		dialogPanel.add(messageLine3, null);
		dialogPanel.add(buttonPanel, null);
		buttonPanel.add(leftButton, null);
		buttonPanel.add(rightButton, null);

		Ethno.dialogCancel = true;
		leftButton.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(ActionEvent e) {
				leftButton_actionPerformed(e);
			}
		});
		rightButton.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(ActionEvent e) {
				rightButton_actionPerformed(e);
			}
		});
	}

	protected void processWindowEvent(WindowEvent e) {
		if (e.getID() == WindowEvent.WINDOW_CLOSING) {
			cancel();
		}
		super.processWindowEvent(e);
	}

	void cancel() {
		dispose();
	}

	void rightButton_actionPerformed(ActionEvent e) {
		cancel();
	}

	void leftButton_actionPerformed(ActionEvent e) {
		Ethno.dialogCancel = false;
		cancel();
	}
}