
import java.awt.BorderLayout;
import java.awt.Button;
import java.awt.Color;
import java.awt.Frame;
import java.awt.Label;
import java.awt.Panel;
import java.awt.TextArea;
import java.awt.event.ActionEvent;
import java.util.Vector;

/** This form uses text copy and text paste to save and restore models. */
public class ImportExportCard extends Panel {

	static String importingMessage;

	Panel topPanel = new Panel();

	Panel instructionPanel = new Panel();

	Panel checkboxPanel = new Panel();

	Panel buttonsPanel = new Panel();

	Panel textBoxesPanel = new Panel();

	Button clearAllButton = new Button();

	Button selectAll = new Button();

	Button importSequence = new Button();

	Button importStudy = new Button();

	Button importAppend = new Button();

	Button copyAll = new Button();

	Label instruction1 = new Label();

	Label instruction2 = new Label();

	TextArea importExportBox = new TextArea(28, 62);

	BorderLayout instructionPanelLayout = new BorderLayout();

	BorderLayout pageLayout = new BorderLayout();

	BorderLayout topPanelLayout = new BorderLayout();

	public ImportExportCard() {
		try {
			jbInit();
		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}

	void jbInit() throws Exception {
		this.setBackground(Color.white);
		topPanel.setBackground(Color.white);
		instructionPanel.setBackground(Color.cyan);
		instruction1.setBackground(Color.cyan);
		instruction2.setBackground(Color.cyan);
		textBoxesPanel.setBackground(Color.white);
		checkboxPanel.setBackground(Color.white);
		buttonsPanel.setBackground(Color.white);
		clearAllButton.setBackground(Color.green);
		selectAll.setBackground(Color.green);
		importSequence.setBackground(Color.green);
		importAppend.setBackground(Color.green);
		importStudy.setBackground(Color.green);

		instruction1.setText(Ethno.interfaceTexts.getString("instruction1"));
		instruction2.setText(Ethno.interfaceTexts.getString("instruction2"));
		clearAllButton.setLabel(Ethno.interfaceTexts.getString("clearAll"));
		selectAll.setLabel(Ethno.interfaceTexts.getString("selectAll"));
		importSequence.setLabel(Ethno.interfaceTexts
			.getString("importSequence"));
		importStudy.setLabel(Ethno.interfaceTexts.getString("importStudy"));
		importAppend.setLabel(Ethno.interfaceTexts.getString("importAppend"));
		copyAll.setLabel(Ethno.interfaceTexts.getString("copy"));
		copyAll.setVisible(false);

		this.setLayout(pageLayout);
		topPanel.setLayout(topPanelLayout);
		instructionPanel.setLayout(instructionPanelLayout);
		instruction1.setAlignment(1);
		instruction2.setAlignment(1);

		this.add(buttonsPanel, BorderLayout.SOUTH);
		this.add(topPanel, BorderLayout.NORTH);
		topPanel.add(instructionPanel, BorderLayout.CENTER);
		instructionPanel.add(instruction1, BorderLayout.NORTH);
		instructionPanel.add(instruction2, BorderLayout.CENTER);
		topPanel.add(checkboxPanel, BorderLayout.SOUTH);
		buttonsPanel.add(selectAll, null);
		buttonsPanel.add(clearAllButton, null);
		buttonsPanel.add(importSequence, null);
		buttonsPanel.add(importStudy, null);
		buttonsPanel.add(importAppend, null);
		buttonsPanel.add(copyAll, null);
		this.add(textBoxesPanel, BorderLayout.CENTER);
		textBoxesPanel.add(importExportBox, null);
		clearAllButton.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(ActionEvent e) {
				clearText();
			}
		});
		selectAll.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(ActionEvent e) {
				selectAllText();
			}
		});
		importSequence.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(ActionEvent e) {
				importASequence();
			}
		});
		importStudy.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(ActionEvent e) {
				if ((importExportBox.getText()).indexOf("?xml") == -1) {
					// Reading text formatted before 2007.
					restoreStudyFromNonXML();
				} else {
					restoreStudyFromXML();
				}
			}
		});
		importAppend.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(ActionEvent e) {
				appendStudy();
			}
		});
	}

	/**
	 * Imports a list of events consisting of shortNames, plus optionally: long
	 * name, quote, comment, and event-frame entries, in that order, separated
	 * by tabs; event frame categories may contain multiple percepts separated
	 * by ", ".
	 */
	void importASequence() {
		String unparsedText;
		String lineOfText;
		String[] deedFields;
		Deed theDeed;
		int indexToNextLine;
		int startOfField, indexToNextField;
		int startOfSubField, indexToNextSubField;
		String perceptName;
		String endOfLineMarker = Ethno.interfaceTexts.getString("newLine");
		String endOfFieldMarker = Ethno.interfaceTexts.getString("endField");
		String endOfSubfieldMarker =
			Ethno.interfaceTexts.getString("endSubField");
		String entityPercept = Ethno.interfaceTexts.getString("entityFlag");
		String personPercept = Ethno.interfaceTexts.getString("personFlag");
		String lineNumberText;
		String actionPercept = Ethno.interfaceTexts.getString("actionFlag");
		int maxLength = DefineSequenceCard.MAX_SHORT_NAME_LENGTH;
		int subfieldMarkerSize = endOfSubfieldMarker.length();
		int entityFlagSize = entityPercept.length();
		int personFlagSize = personPercept.length();
		int actionFlagSize = actionPercept.length();
		deedFields = new String[12];
		Ethno.defineSequenceCard.narrativeTextArea.setText("");

		unparsedText = importExportBox.getText();
		// Incorporate each line as a deed.
		int lineNumber = 0;
		while (unparsedText.length() > 0) {
			lineNumberText = (new Integer(lineNumber++)).toString();
			indexToNextLine = unparsedText.indexOf(endOfLineMarker);
			if (indexToNextLine < 0) { // Missing return at end.
				// Get final deed.
				lineOfText = Ethno.cleanTheString(unparsedText);
				unparsedText = "";
			} else {
				// Get the next deed.
				lineOfText =
					Ethno.cleanTheString(unparsedText.substring(0,
						indexToNextLine));
				unparsedText =
					unparsedText.substring(indexToNextLine + 1,
						unparsedText.length());
			}
			// Make sure last field has a terminator:
			lineOfText = lineOfText + endOfFieldMarker;
			// Clear the array of slots for text fields.
			for (int i = 0; i < deedFields.length; i++) {
				deedFields[i] = "";
			}
			startOfField = 0;
			for (int i = 0; i < deedFields.length; i++) {
				// Grab text in next field, of 12 fields.
				indexToNextField =
					lineOfText.indexOf(endOfFieldMarker, startOfField);
				if (indexToNextField < 0) {
					// No more fields to read for this deed.
					break;
				} else {
					// Put this field into the array of field-texts.
					deedFields[i] =
						lineOfText.substring(startOfField, indexToNextField);
					// Set start of next field past the tab.
					startOfField = indexToNextField + 1;
				}
			}
			if (deedFields[0].length() > maxLength) {
				// Warn about overly long short names, but don't stop.
				CancelOkDialog whoops =
					new CancelOkDialog((Frame) this.getParent().getParent(),
						Ethno.interfaceTexts
							.getString("problemEncounteredText")
							+ lineNumberText, deedFields[0],
						Ethno.interfaceTexts
							.getString("abbreviationTooLongError")
							+ (new Integer(maxLength)).toString());
				whoops.setVisible(true);
			}
			if (deedFields[0].equals("")) {
				// Warn about an empty short name, and quit.
				CancelOkDialog whoops =
					new CancelOkDialog((Frame) this.getParent().getParent(),
						Ethno.interfaceTexts
							.getString("problemEncounteredText")
							+ lineNumberText,
						Ethno.interfaceTexts.getString("missingTextError"), "");
				whoops.setVisible(true);
				return;
			} else {
				// Create a new deed with the given short name and long name.
				theDeed = new Deed();
				theDeed.shortName = deedFields[0];
				theDeed.sourceText.concat(deedFields[2]);
				// Incorporate the event into the corpus.
				int indexToNewEvent = Ethno.deeds.insertAlphabetically(theDeed);
				if (indexToNewEvent < 0) {
					// This is a duplicate.
					indexToNewEvent =
						Ethno.deeds.findPositionOfElement(theDeed.shortName);
					// Append quotes to remember all of them with repeats.
					((Deed) Ethno.deeds.elementAt(indexToNewEvent)).sourceText
						.concat(deedFields[2]);
				} else { // Not a repeat.
					// Incorporate long name.
					theDeed.verboseEventName = deedFields[1];
					// Incorporate source text.
					theDeed.sourceText = deedFields[2];
					// Incorporate comment.
					theDeed.comment = deedFields[3];
					// Incorporate Event Frame codings and their percepts.
					for (int i = 4; i < deedFields.length; i++) {
						if (deedFields[i].length() == 0) {
							continue;
						}
						// We have one or more percepts for this frame category.
						startOfSubField = 0;
						do {
							// Find one or more subfields in this field.
							indexToNextSubField =
								deedFields[i].indexOf(endOfSubfieldMarker);
							if (indexToNextSubField < 0) {
								// This is the last subfield.
								indexToNextSubField = deedFields[i].length();
							}
							lineOfText =
								deedFields[i].substring(startOfSubField,
									indexToNextSubField);
							
							// Sort out percepts using the flags - E: , P: , A:
							if (lineOfText.contains(entityPercept)) {
								Ethno.showElementCard
									.setCurrentElementType(Ethno.ENTITY);
								perceptName =
									lineOfText.substring(entityFlagSize);
							} else if (lineOfText.contains(personPercept)) {
								Ethno.showElementCard
									.setCurrentElementType(Ethno.PERSON);
								perceptName =
									lineOfText.substring(personFlagSize);
							} else if (lineOfText.contains(actionPercept)) {
								Ethno.showElementCard
									.setCurrentElementType(Ethno.ACTION);
								perceptName =
									lineOfText.substring(actionFlagSize);
							} else {
								// Warn about an unfound percept flag,
								// and quit.
								CancelOkDialog whoops =
									new CancelOkDialog(
										(Frame) this.getParent().getParent(),
										Ethno.interfaceTexts
											.getString("problemEncounteredText")
											+ lineNumberText, lineOfText,
										Ethno.interfaceTexts
											.getString("invalidFlag"));
								whoops.setVisible(true);
								return;
							}
							int elementType = ShowPerceptCard.currentElementType;
							int eventFrameCell = i - 4;
							incorporateElement (perceptName, elementType, theDeed, eventFrameCell);

							if (indexToNextSubField == deedFields[i].length()) {
								deedFields[i] = ""; // Done with this field.
							} else {
								deedFields[i] =
									deedFields[i].substring(indexToNextSubField
										+ subfieldMarkerSize,
										deedFields[i].length());
							}
						} while (deedFields[i].length() != 0);
					}
				}
				Deed x = (Deed) Ethno.deeds.elementAt(indexToNewEvent);
				Ethno.sequence.addElement(x);
				// Add the quote to the text area on DefineSequenceCard.
				Ethno.defineSequenceCard.narrativeTextArea
					.append(theDeed.sourceText + endOfLineMarker);
			}
		} // End while (unparsedText.length() > 0).
		Ethno.controls.rebuildEventsChoice();
		Ethno.controls.rebuildElementChoices();
		importingMessage = Ethno.interfaceTexts.getString("gotSequence");
		clearText();
		importExportBox.setText(importingMessage);
	} // End importASequence.
	
	/** Incorporate a given entity, agent, or action. */
	void incorporateElement 
	(String lineOfText, int elementType, Deed theDeed, int eventFrameCell) {
		String possessionMark = Ethno.interfaceTexts.getString("possessionDivider");
		String generalizeMark = Ethno.interfaceTexts.getString("generalizationDivider");
		PerceptList elementList =
				PerceptList.getPerceptList(ShowPerceptCard.currentElementType);
		PerceptList entityList = PerceptList.getPerceptList(0);
		PerceptList agentList = PerceptList.getPerceptList(1);
		PerceptList actionList = PerceptList.getPerceptList(2);
		// lineOfText must be a generalization, a possessive, or simple entry.
		
		// Consider generalizations first, since possessives enter into generalizations.
		// E.g., Mary < secretary|John
		if (lineOfText.contains(generalizeMark)) {
			// Field contains a generalization, e.g., robin<bird.
			int separator = lineOfText.indexOf(generalizeMark, 0);
			// Lower element is specified to be in elementList.
			String lowerText = lineOfText.substring(0,separator);
			Percept lower = new Percept();
			lower.shortName = lowerText;
			int indexToLower = elementList.insertAlphabetically(lower);
			if (indexToLower < 0) {
				// A repeat.
				indexToLower = elementList.findPositionOfElement(lowerText);
				lower = (Percept) elementList.elementAt(indexToLower);
			}
			theDeed.eventFrame[eventFrameCell].addElement(lower);
			// Now incorporate the higher element.
			String higherText = lineOfText.substring(separator + 1);
			if (higherText.contains("<")) {
				CancelOkDialog whoops =
					new CancelOkDialog((Frame) this.getParent().getParent(),
						Ethno.interfaceTexts
						.getString("importProblem"),
						higherText, Ethno.interfaceTexts
							.getString("invalidEntry"));
				whoops.setVisible(true);
				return;
			}
			Percept higher = new Percept();
			int indexToHigher;
			indexToHigher = entityList.findPositionOfElement(higherText);
			if (indexToHigher > -1) { // Owner is an entity.
				higher = (Percept) entityList.elementAt(indexToHigher);
			} else {
				indexToHigher = agentList.findPositionOfElement(higherText);
				if (indexToHigher > -1) { // Owner is an agent (Person).
					higher = (Percept) agentList.elementAt(indexToHigher);
				} else {
					indexToHigher = actionList.findPositionOfElement(higherText);
					if (indexToHigher > -1) { // Owner is an action.
						higher = (Percept) actionList.elementAt(indexToHigher);
					} else { // Not a repeat. Insert in same list as the full item.
						higher.shortName = higherText;
						elementList.insertAlphabetically(higher);
					}
				}
			}
			theDeed.eventFrame[eventFrameCell].addElement(higher);
			// Generalize lower element to higher.
			Percept focalElement = lower;
			Percept generalizedElement = higher;
			if (elementList.downwardLinks(focalElement).contains(generalizedElement)
					|| elementList.upwardLinks(focalElement).contains(generalizedElement)) {
					// Already related.
					return;
				}
				// Remove any pre-existing generalizations that are generalizations of
				// the new generalization.
				Vector generalizationsOfNewGeneralization =
					elementList.upwardLinks(generalizedElement);
				int indexOfTestElement;
				for (int i = focalElement.implications.size() - 1; i >= 0; i--) {
					indexOfTestElement = elementList
						.findPositionOfElement(((Relation) focalElement.implications
							.elementAt(i)).implicated);
					Object testElement = elementList.elementAt(indexOfTestElement);
					if (generalizationsOfNewGeneralization.contains(testElement)) {
						focalElement.implications.removeElementAt(i);
					}
				}
				// Add the element as a generalization.
				focalElement.implications.addElement(new Relation(
					higherText, true, false));
			return; // Done with entry containing a generalization.

		} else if (lineOfText.contains(possessionMark)) {
			// Field contains a possessive: e.g., thing|someone (something of someone)
			// First incorporate the full item in the specified percept list.
			Percept element = new Percept();
			element.shortName = lineOfText;
			int indexToNewElement = elementList.insertAlphabetically(element);
			if (indexToNewElement < 0) {
				// A repeat.
				indexToNewElement = elementList.findPositionOfElement(lineOfText);
				element = (Percept) elementList.elementAt(indexToNewElement);
			}
			theDeed.eventFrame[eventFrameCell].addElement(element);
			// Now incorporate the owned element.
			int pipe = lineOfText.indexOf(possessionMark, 0);
			String ownedText = lineOfText.substring(0,pipe);
			Percept owned = new Percept();
			int indexToOwned;
			indexToOwned = entityList.findPositionOfElement(ownedText);
			if (indexToOwned > -1) { // Owned is an entity.
				owned = (Percept) entityList.elementAt(indexToOwned);
			} else {
				indexToOwned = agentList.findPositionOfElement(ownedText);
				if (indexToOwned > -1) { // Owner is an agent (Person).
					owned = (Percept) agentList.elementAt(indexToOwned);
				} else {
					indexToOwned = actionList.findPositionOfElement(ownedText);
					if (indexToOwned > -1) { // Owner is an action.
						owned = (Percept) actionList.elementAt(indexToOwned);
					} else { // Not a repeat. Insert in same list as the full item.
						owned.shortName = ownedText;
						elementList.insertAlphabetically(owned);
					}
				}
			}
			theDeed.eventFrame[eventFrameCell].addElement(element);
			// Generalize owned|owner to owned, e.g., secretary|Jack < secretary.
			Percept focalElement = element;
			Percept generalizedElement = owned;
			if (elementList.downwardLinks(focalElement).contains(generalizedElement)
					|| elementList.upwardLinks(focalElement).contains(generalizedElement)) {
					// Already related.
					return;
				}
				// Remove any pre-existing generalizations that are generalizations of
				// the new generalization.
				Vector generalizationsOfNewGeneralization =
					elementList.upwardLinks(generalizedElement);
				int indexOfTestElement;
				for (int i = focalElement.implications.size() - 1; i >= 0; i--) {
					indexOfTestElement = elementList
						.findPositionOfElement(((Relation) focalElement.implications
								.elementAt(i)).implicated);
					Object testElement = elementList.elementAt(indexOfTestElement);
					if (generalizationsOfNewGeneralization.contains(testElement)) {
						focalElement.implications.removeElementAt(i);
					}
				}
				// Add the element as a generalization.
				focalElement.implications.addElement(new Relation(
					ownedText, true, false));
				return; // Done with entry containing a possessive.
		} 
		// lineOfText contains a simple entry.
		// Incorporate the Sitem in the specified percept list.
		Percept element = new Percept();
		element.shortName = lineOfText;
		int indexToNewElement = elementList.insertAlphabetically(element);
		if (indexToNewElement < 0) {
			// A repeat.
			indexToNewElement = elementList.findPositionOfElement(lineOfText);
			element = (Percept) elementList.elementAt(indexToNewElement);
		}
		theDeed.eventFrame[eventFrameCell].addElement(element);

	} // End incorporateElement.

	/** Clear the text in the box. */
	void clearText() {
		importExportBox.setText("");
		importExportBox.requestFocus();
	}

	/** Select the text in the box. */
	void selectAllText() {
		importExportBox.select(0, 0);
		importExportBox.selectAll();
		importExportBox.requestFocus();
	}

	/** Restore the model represented by the text in the box. */
	void restoreStudyFromNonXML() {
		String dataString;
		dataString = importExportBox.getText();
		if ((dataString.indexOf('@') == -1) || (dataString.indexOf('#') == -1)) {
			CancelOkDialog whoops =
				new CancelOkDialog((Frame) this.getParent().getParent(),
					Ethno.interfaceTexts.getString("invalidText"),
					Ethno.interfaceTexts.getString("invalidDataText"), "");
			whoops.setVisible(true);
			return;
		} else {
			// Clear the old analysis before appending.
			Ethno.sequence = null;
			Ethno.deeds = null;
			Ethno.entities = null;
			Ethno.people = null;
			Ethno.actions = null;
			Ethno.sequence = new PerceptList();
			Ethno.deeds = new PerceptList();
			Ethno.entities = new PerceptList();
			Ethno.people = new PerceptList();
			Ethno.actions = new PerceptList();
			appendStudy(); // Continue in append routine.
		}
	} // End restoreStudyFromNonXML.

	/** Restore the model represented by the XML text in the box. */
	void restoreStudyFromXML() {
		String dataString;
		dataString = importExportBox.getText();
		if ((dataString.indexOf("<" + SavedData.episode + ">") < 0)
			|| (dataString.indexOf("<" + SavedData.event + ">") < 0)) {
			CancelOkDialog whoops =
				new CancelOkDialog((Frame) this.getParent().getParent(),
					Ethno.interfaceTexts.getString("invalidText"),
					Ethno.interfaceTexts.getString("invalidDataText"), "");
			whoops.setVisible(true);
			return;
		} else {
			// Clear the old analysis before appending.
			Ethno.sequence = null;
			Ethno.deeds = null;
			Ethno.entities = null;
			Ethno.people = null;
			Ethno.actions = null;
			Ethno.linkingHistory = "";
			Ethno.sequence = new PerceptList();
			Ethno.deeds = new PerceptList();
			Ethno.entities = new PerceptList();
			Ethno.people = new PerceptList();
			Ethno.actions = new PerceptList();
			appendStudy();
			// Continue in append routine.
		}
	} // End restoreStudyFromXML.

	void appendStudy() {
		String dataString;
		dataString = importExportBox.getText();
		SavedData corpus = new SavedData(dataString);
		if (dataString.indexOf("?xml") == -1) {
			// Reading text formatted before 2007.
			corpus.importingNonXML();
		} else {
			corpus.importingXML();
		}
		Ethno.controls.rebuildEventsChoice();
		Ethno.controls.rebuildOperationsChoice();
		Ethno.defineSequenceCard.reconstructSequenceDisplay();
		importingMessage = Ethno.interfaceTexts.getString("success");
		clearText();
		importExportBox.setText(importingMessage);
	} // End appendStudy.

	/** Display the current model as text in the box. */
	void displayModelAsString(boolean generalizedModelInsteadOfConcrete) {
		SavedData corpus = new SavedData();
		String dataString = corpus.exportXML(generalizedModelInsteadOfConcrete);
		Ethno.importExportCard.importExportBox.setText(dataString);
		Ethno.importExportCard.importExportBox.invalidate();
		Ethno.importExportCard.importExportBox.validate();
		dataString = "";
		corpus = null;
	} // End displayModelAsString.

}