
import java.util.ListResourceBundle;

/** Texts used to build the interface. */
public class InterfaceTexts extends ListResourceBundle {
	static final Object[][] contents =
		{
			{ "newLine", "\n" },
			{ "endField", "\t" },
			{ "endSubField", ", " },
			{ "generalizationDivider", "<" },
			{ "possessionDivider", "|" },
			{ "commaSpace", ", " },
			{ "space", " " },
			{ "indent", "  " },
			{ "colonSpace", ": " },
			{ "endPren", ")" },
			{ "okText", "OK" },
			{ "cancelText", "Cancel" },
			{ "invalidURL", "Invalid URL: " },
			{ "summarizedMark", "_" },

			// ControlMenus and associated dialogs.
			{
				"operationLineName",
				new String[] { "Operations", "Define sequence", "Link actions",
					"Chart", "Import-Export", "Report page", "Export abstract" } },
			{ "eventsTitleText", "Actions" },
			{ "newEntityText", "New entity" },
			{ "newPersonText", "New agent" },
			{ "newActionText", "New act" },
			{
				"graphModeLine",
				new String[] { "Inspecting", "Editing", "Summarizing",
					"Generalizing", "Testing", "Experimenting", "Print" }
			// Printing has to be last.
			},
			{ "cannotLink1", "Not enough actions" },
			{ "cannotLink2", "to define a logical structure." },

			// DefineSequenceCard and its dialogs.
			{ "abbreviationLabel", "Next Action:" },
			{ "abbreviationInstruction",
				"(Type a short name for the action, and press Enter.)" },
			{ "sequenceTitle", "Sequence" },
			{ "textCut", "Cut" },
			{ "textMove", "Move" },
			{ "textRepeat", "Repeat" },
			{ "textSelect", "Find" },
			{ "copyrightText",
				"Ethno,  1988, 1997, 2001, 2007, 2012, 2014 D. Heise." },
			{ "duplicateDeedError", "The abbreviated name is a duplicate." },
			{
				"initialNarrativeText",
				"\n\n\n\n\n\n\n\n\n\nDelete this text and copy the "
					+ "narrative\nof the episode into this space. "
					+ "The\nnarrative will be saved when you export"
					+ "\nyour work.\n\nText that is selected here "
					+ "when you\ndefine an action will be saved as "
					+ "the\nsource text for the action, even though\n"
					+ "the selection loses visual emphasis\nwhile "
					+ "you type the action name." },
			{ "cautionText", "Caution" },
			{ "removingDeedWarningText", "Remove this action and its links?" },
			{ "removeText", "Remove Action" },
			{ "episodeStatisticsTitle", "EPISODE STATISTICS." },
			{ "numberOfDefinedEvents", "Number of defined actions: " },
			{ "numberOfEventOccurrences", "Number of action occurrences: " },
			{ "frequencyTitle", "  FREQUENCY" },
			{ "priorityTitle", "  PRIORITY" },
			{ "freedomTitle", "   FREEDOM" },
			{ "nameTitle", "ACTION" },
			{ "", "" },

			// DefineLinksCard and its dialogs.
			{ "problemEncounteredText",
				"Problem encountered with short name." },
			{ "missingTextError",
				"You must provide an abbreviated name for every action." },
			{ "abbreviationTooLongError",
				"Exceeds maximum number of characters: " },
			{ "questionTypesLabelText", "Type of Question" },
			{
				"questionTypes",
				new String[] { "Prerequisite", "Implication",
					"Historical Causation", "Counterfactual" } },
			{ "redoText", "Redo" },
			{ "restartText", "Undid linking of actions." },
			{ "logicLabelText", "Begin questioning with:" },
			{ "localText", "End actions" },
			{ "remoteText", "Initial actions" },
			{ "answerRecordLabelText", "Log of answers and comments" },
			{ "PrerequisiteText",
				new String[] { "Does", "require", "or a similar action?" } },
			{
				"ImplicationText",
				new String[] { "Does occurrence of", "imply",
					"or a similar action?" } },
			{
				"CausationText",
				new String[] { "Is", "or a similar action a cause of",
					"in the circumstances that existed?" } },
			{
				"CounterfactualText",
				new String[] { "Suppose an action like", "does not occur. Can",
					"occur anyway?" } },
			{ "yesText", "Yes" },
			{ "noText", "No" },
			{ "nextText", "Next question" },
			{ "noNextText", "No. Next question" },
			{ "yesNextText", "Yes. Next question" },
			{ "notText", "not " },
			{ "linkedText", "linked: " },
			{ "startAtEndText", "(End actions, " },
			{ "workingUpwardText", "(Working upward, " },
			{ "startAtInitialText", "(Initial actions, " },
			{ "workingDownwardText", "(Working downward, " },
			{ "doneLinkingText", " LINKING COMPLETED." },
			{ "questionEndPrenText", " question)" },
			{ "linkingCompletedTitle", "Linking Completed" },
			{ "linkingCompletedText1",
				"You have finished specifying links between actions. Your answers" },
			{ "linkingCompletedText2",
				"and comments will be saved when you export this study.." },
			{ "eraseTextTitle", "Unlink Actions" },
			{ "eraseText",
				"Erase links for actions back through the selected one?" },
			{ "saveLogText", "Save Extra Comments" },

			// ShowDeedCard.
			{
				"eventFrameName",
				new String[] { "Agents", "Acts", 
					"Objects", "Instruments",
					"Alignments", "Settings", 
					"Products", "Beneficiaries", "" } },
			{ "experiencerText", "(Experiencers)" },
			{ "abbreviationTitleText", "Short name of action" },
			{ "descriptionTitleText", "Action description" },
			{ "quoteTitleText", "Source text" },
			{ "commentTitleText", "Comments" },
			{ "prerequisiteTitleText", "Prerequisites" },
			{ "consequenceTitleText", "Consequences" },
			{ "summarizationTitleText", "Summarizes" },
			{ "generalizesTitleText", "Instantiated by" },
			{ "noInstantiationTitleText", "No instantiations" },
			{ "generalizationTitleText", "Instantiates" },
			{ "linkedBoxText", "Linked" },
			{ "disjunctiveBoxText", "Disjunctive prerequisites" },
			{ "repeatableBoxText", "Repeats without depletion" },
			{ "depleted", "depleted" },
			{ "inProcess", "in-process" },
			{ "summarized", "summarized" },

			// AbstractionDialog.
			{ "summarizableText", "Summarizable sequences" },
			{ "summaryNameText", "Short name for summary action" },
			{ "replaceSequenceText", "Summarize sequence permanently" },
			{ "summarizedIn", ": summarized in " },
			{ "instantiatesButtonText", "Instantiates" },
			{ "deleteLinkText", "Delete link" },
			{ "generalizationNameText", "Short name for new generalized action" },
			{ "addGeneralizationText", "Incorporate new action" },
			{ "addInstantiation", ": added as instantiation of " },
			{ "cutInstantiation", ": deleted instantiation of " },
			{ "doneButtonText", "Done" }, // Also used in DefineLinksCard

			// ChartCard
			{ "finishedAllText", "All actions have been analyzed." },
			{ "produceStatisticsText",
				"Action statistics have been printed on the Report page." },
			{ "problemHeaderText", "Problem" },

			// ConstrainAssociations dialog.
			{ "continueButtonLabel", "Continue" },
			{
				"instructionConstrainDialog1",
				"Mark categories in each column to determine how associations should be computed." },
			{
				"instructionConstrainDialog2",
				"For example, to see how the focal agent relates to others as beneficiaries," },
			{
				"instructionConstrainDialog3",
				"mark Agent in the left column and Beneficiaries in the right column. (Mark or unmark by clicking the category.)" },
			{ "constrainingDialogErrorMsg",
				"At least one category must be chosen in each list." },
			{ "leftTitle", "Focal element" },
			{ "rightTitle", "Other elements" },

			// ShowElementCard
			{
				"elementName",
				new String[] { "Name of entity:", "Name of agent:",
					"Name of action:" } },
			{ "deletionWord", "delete" },
			{ "cutAbstractionText", "Cut selected generalization" },
			{ "addAbstractionText", "Choose a generalization" },
			{ "returnToEventText", "Return to action" },
			{ "constraintsText", "Constrain associations" },
			{ "generalizeText", "Generalize" },
			{ "computeText", "Compute associations" },
			{ "expansionText", "Concrete forms" },
			{ "concreteEvents", "Concrete" },
			{ "generalizedEvents", "Generalized" },
			{ "eventsContainingLabelText", "Containing Actions" },
			{ "actionAssociationsLabelText", "Act associations" },
			{ "entityAssociationsLabelText", "Entity associations" },
			{ "personAssociationsLabelText", "Agent associations" },

			// RefineModelDialog.
			{ "regardingText", "Regarding: " },
			{ "unusedText1", "Accomplishments of this action still exist" },
			{ "unusedText2", "from the action's last occurrence." },
			{ "unprimedText", "This action's prerequisites seem unfulfilled." },
			{ "solutionsTitleText", "Overview of Solutions" },
			{ "proposedSolutionTitleText", "Proposed Solution" },
			{ "nextButtonText", "Go to next solution" },
			{ "adoptButtonText", "Adopt this solution" },
			{ "stubText", "The action " },
			{ "cuttingLinkSolution",
				" is not a prerequisite for the action shown here." },
			{ "nondepletingLinkSolution",
				" is not used up by the action shown here." },
			{ "commutingConsequenceSolution",
				"This action is enabled by occurrence of the outcome shown here." },
			{ "unrecordedPrerequisiteSolution",
				"The prerequisite shown here happened but was unrecorded." },
			{ "disjunctiveSolution",
				"Occurrence of any prerequisite listed here enables this action." },
			{ "newDisjunctivePrerequisite",
				"This action can be enabled by occurrence of the action shown here." },
			{ "addingLinkSolution",
				"This action is a prerequisite for the action shown here." },
			{ "unrecordedConsequenceSolution",
				"The consequence shown here happened but was unrecorded." },
			{ "repeatableSolution",
				"This action can occur repeatedly without regard to its consequences." },
			{ "newEventSolution",
				"Incorporate this new consequence to deplete the action." },
			{ "cutLink", " - cut link." },
			{ "addLink", ": added link to " },

			// RelationDialog.
			{ "fromText", "Link from" },
			{ "toText", "to" },
			{ "lowerText", "Upper action enables lower action" },
			{ "upperText", "Lower action enables upper action" },
			{ "newCommuter", "Toggle commutation for this relation?" },
			{ "addedCommuter", " - commutation added." },
			{ "removedCommuter", " - commutation removed." },
			{ "L_DepletesUText", "Lower action depletes upper action" },
			{ "U_DepletesLText", "Upper action depletes lower action" },
			{ "deleteLinkText", "Delete Link" },
			{ "addLinkText", "Add Link" },
			{ "linkOkText", "Keep Link" },

			// Output printed to report page.
			{ "reportTitleText", "ASSOCIATIONS OF:" },

			// Import-Export.
			{ "clearAll", "Clear Text" },
			{ "selectAll", "Select Text" },
			{ "importSequence", "Import Sequence" },
			{ "importStudy", "Restore Study" },
			{ "importAppend", "Append Study" },
			{ "entityFlag", "E: " },
			{ "personFlag", "P: " },
			{ "actionFlag", "A: " },
			{ "importProblem", "Problem: " },
			{ "invalidFlag",
				"Invalid indicator of entity, agent, or action. Filling of action frame aborted." },
			{ "invalidEntry", "Contains invalid character." },
			{ "instruction1",
				"To save, click Select-Text, copy, and paste to a text processor. To restore, click Clear-Text, " },
			{ "instruction2",
				"paste a prior analysis into the box, and click the Restore-Study button." },
			{ "invalidText", "Invalid data" },
			{ "invalidDataText",
				"The text box does not contain valid ESA data." },
			{ "noEvents", "No actions found." },
			{ "unnamedPercept", "Percept with no name." },
			{ "unnamedDeed", "Action with no name." },
			{ "unnamedImplication", ": implication with no name." },
			{ "missingElement", "Cannot find " },
			{ "success", "The study is restored." },
			{ "gotSequence", "The sequence is incorporated." },
			{ "duplicates", "The following actions repeated." },
			{ "copy", "Copy" },
			{ "paste", "Append" },
			{ "cannotCopy",
				"Either the clipboard is empty or it does not contain text." },
			{ "importError", "Sequence ERROR: " },
			// XML tags.
			{ "EPISODE", "EPISODE" }, { "ENTITY", "ENTITY" },
			{ "PERSON", "PERSON" }, { "BEHAVIOR", "BEHAVIOR" },
			{ "EVENT", "ACTION" }, { "SEQUENCE", "SEQUENCE" },
			{ "NAME", "NAME" }, { "IMPLIED", "IMPLIED" },
			{ "LONG_NAME", "LONG_NAME" }, { "SOURCE_TEXT", "SOURCE_TEXT" },
			{ "COMMENT", "COMMENT" }, { "IS_LINKED", "IS_LINKED" },
			{ "IS_DISJUNCTIVE", "IS_DISJUNCTIVE" },
			{ "IS_REPEATABLE", "IS_REPEATABLE" },
			{ "IS_GENERALIZATION", "IS_GENERALIZATION" },
			{ "IS_INSTANTIATED", "IS_INSTANTIATED" },
			{ "IS_SUMMARIZED", "IS_SUMMARIZED" },
			{ "EVENT_FRAME", "ACTION_FRAME" }, { "AGENT", "AGENT" },
			{ "ACT", "ACT" }, { "OBJECT", "OBJECT" },
			{ "INSTRUMENT", "INSTRUMENT" }, { "ALIGNMENT", "ALIGNMENT" },
			{ "SETTING", "SETTING" }, { "PRODUCT", "PRODUCT" },
			{ "BENEFICIARY", "BENEFICIARY" }, { "IMPLIES", "IMPLIES" },
			{ "ANTECEDENT", "ANTECEDENT" },
			{ "DEPLETES_ANTECEDENT", "DEPLETES_ANTECEDENT" },
			{ "COMMUTES_WITH_ANTECEDENT", "COMMUTES_WITH_ANTECEDENT" },
			{ "GENERALIZES_TO", "GENERALIZES_TO" },
			{ "SUMMARIZES", "SUMMARIZES" }, { "SEQUENCE", "SEQUENCE" },
			{ "RECORDED_EVENT", "RECORDED_ACTION" },
			{ "LINKING_HISTORY", "LINKING_HISTORY" },
			{ "NARRATIVE", "NARRATIVE" }

		};

	public Object[][] getContents() {
		return contents;
	}
}
