
/** Transforms a model into a string, or parses a string representing a model. */
class SavedData {

	String data;

	static String episode = Ethno.interfaceTexts.getString("EPISODE");

	static String entity = Ethno.interfaceTexts.getString("ENTITY");

	static String person = Ethno.interfaceTexts.getString("PERSON");

	static String behavior = Ethno.interfaceTexts.getString("BEHAVIOR");

	static String event = Ethno.interfaceTexts.getString("EVENT");

	static String sequence = Ethno.interfaceTexts.getString("SEQUENCE");

	static String name = Ethno.interfaceTexts.getString("NAME");

	static String implied = Ethno.interfaceTexts.getString("IMPLIED");

	static String longName = Ethno.interfaceTexts.getString("LONG_NAME");

	static String sourceText = Ethno.interfaceTexts.getString("SOURCE_TEXT");

	static String comment = Ethno.interfaceTexts.getString("COMMENT");

	static String isLinked = Ethno.interfaceTexts.getString("IS_LINKED");

	static String isDisjunctive = Ethno.interfaceTexts
		.getString("IS_DISJUNCTIVE");

	static String isRepeatable = Ethno.interfaceTexts
		.getString("IS_REPEATABLE");

	static String isGeneralization = Ethno.interfaceTexts
		.getString("IS_GENERALIZATION");

	static String isInstantiated = Ethno.interfaceTexts
		.getString("IS_INSTANTIATED");

	static String isSummarized = Ethno.interfaceTexts
		.getString("IS_SUMMARIZED");

	static String eventFrame = Ethno.interfaceTexts.getString("EVENT_FRAME");

	static String implies = Ethno.interfaceTexts.getString("IMPLIES");

	static String generalizesTo = Ethno.interfaceTexts
		.getString("GENERALIZES_TO");

	static String summarizes = Ethno.interfaceTexts.getString("SUMMARIZES");

	static String agent = Ethno.interfaceTexts.getString("AGENT");

	static String act = Ethno.interfaceTexts.getString("ACT");

	static String object = Ethno.interfaceTexts.getString("OBJECT");

	static String instrument = Ethno.interfaceTexts.getString("INSTRUMENT");

	static String alignment = Ethno.interfaceTexts.getString("ALIGNMENT");

	static String setting = Ethno.interfaceTexts.getString("SETTING");

	static String product = Ethno.interfaceTexts.getString("PRODUCT");

	static String beneficiary = Ethno.interfaceTexts.getString("BENEFICIARY");

	static String antecedent = Ethno.interfaceTexts.getString("ANTECEDENT");

	static String depletesAntecedent = Ethno.interfaceTexts
		.getString("DEPLETES_ANTECEDENT");

	static String commutesWithAntecedent = Ethno.interfaceTexts
		.getString("COMMUTES_WITH_ANTECEDENT");

	static String recordedEvent = Ethno.interfaceTexts
		.getString("RECORDED_EVENT");

	static String linkingHistory = Ethno.interfaceTexts
		.getString("LINKING_HISTORY");

	static String narrative = Ethno.interfaceTexts.getString("NARRATIVE");

	public SavedData() { // Exporting.
		data = "";
	}

	public SavedData(String inputString) { // Importing.
		data = inputString;
	}

	/** Represent the model in a single long string. */
	String exporting(boolean generalizedModel) {
		Deed x;
		Percept y;
		data = "";
		// Deal with entities.
		data = data + "@ENTITIES\n";
		if (!generalizedModel) {
			for (int i = 0; i < Ethno.entities.size(); i++) {
				y = (Percept) Ethno.entities.elementAt(i);
				data = data + y.toString(); // Uses toString in Percept.
			}
		}
		// Deal with people.
		data = data + "@PEOPLE\n";
		if (!generalizedModel) {
			for (int i = 0; i < Ethno.people.size(); i++) {
				y = (Percept) Ethno.people.elementAt(i);
				data = data + y.toString();
			}
		}
		// Deal with actions.
		data = data + "@ACTIONS\n";
		if (!generalizedModel) {
			for (int i = 0; i < Ethno.actions.size(); i++) {
				y = (Percept) Ethno.actions.elementAt(i);
				data = data + y.toString();
			}
		}
		// Deal with deeds.
		data = data + "@EVENTS\n";
		for (int i = 0; i < Ethno.deeds.size(); i++) {
			x = (Deed) Ethno.deeds.elementAt(i);
			if (!generalizedModel || (generalizedModel & x.isGeneralization)) {
				data = data + x.toString(generalizedModel); // Uses toString in
				// Deed.
			}
		}
		// Deal with sequence.
		data = data + "@SEQUENCE\n";
		if (!generalizedModel) {
			for (int i = 0; i < Ethno.defineSequenceCard.sequenceDisplay
				.getItemCount(); i++) {
				data =
					data + Ethno.defineSequenceCard.sequenceDisplay.getItem(i)
						+ "\n";
			}
		}
		data = data + "@END\n";
		return data;
	} // End exporting.

	/** Parse a string to re-create the model that the string represents. */
	public void importingNonXML() {
		Deed aDeed;
		Percept aPercept;
		int first, last, index;
		String temp, line;
		// Line separator varies across Java implementations:
		temp = data.replace('\r', '\n');
		data = temp;
		first = 0;
		last = data.indexOf('\n', first); // Skip Entities title.
		first = last + 1;
		while (data.charAt(first) != '@') {
			aPercept = new Percept();
			first = aPercept.fromString(data, first);
			index = Ethno.entities.insertAlphabetically(aPercept);
			if (index < 0) {
				elementError(Ethno.entities, aPercept);
			}
		}
		last = data.indexOf('\n', first); // Skip People title.
		first = last + 1;
		while (data.charAt(first) != '@') {
			aPercept = new Percept();
			first = aPercept.fromString(data, first);
			if (Ethno.people.insertAlphabetically(aPercept) < 0) {
				elementError(Ethno.people, aPercept);
			}
		}
		last = data.indexOf('\n', first); // Skip Actions title.
		first = last + 1;
		while (data.charAt(first) != '@') {
			aPercept = new Percept();
			first = aPercept.fromString(data, first);
			if (Ethno.actions.insertAlphabetically(aPercept) < 0) {
				elementError(Ethno.actions, aPercept);
			}
		}
		last = data.indexOf('\n', first); // Skip Events title.
		first = last + 1;
		while (data.charAt(first) != '@') {
			aDeed = new Deed();
			first = aDeed.fromString(data, first);
			if (Ethno.deeds.insertAlphabetically(aDeed) < 0) {
				eventError(Ethno.deeds, aDeed);
			}
		}
		last = data.indexOf('\n', first); // Skip Sequence title.
		first = last + 1;
		Ethno.defineSequenceCard.sequenceDisplay.removeAll();
		while (data.charAt(first) != '@') {
			last = data.indexOf('\n', first);
			line = data.substring(first, last);
			index = Ethno.deeds.findPositionOfElement(line);
			if (index < 0) {
				ImportExportCard.importingMessage =
					Ethno.interfaceTexts.getString("importError")
						+ (new Integer(line)).toString();
				return;
			} else {
				Ethno.sequence.addElement(Ethno.deeds.elementAt(index));
				Ethno.defineSequenceCard.sequenceDisplay.add(line);
			}
			first = last + 1;
		}
		// Set tiers.
		Ethno.deeds.topoSort();
		Ethno.controls.rebuildEventsChoice();
		Ethno.controls.rebuildElementChoices();
		Ethno.controls.redisplayControlArea(1);
	} // End importingNonXML.

	/** Represent the model in a single long string with XML formatting. */
	String exportXML(boolean generalizedModel) {
		Deed x;
		Percept y;
		String pcdata = " (#PCDATA)>\n";
		// Create the XML Document Type Definition.
		data =
			"<?xml version=\"1.0\"?>\n\n<!DOCTYPE " + episode + "\n[\n"
				+ "<!ELEMENT " + episode + " (" + entity + "*, " + person
				+ "*, " + behavior + "*, " + event + "+, " + sequence
				+ "*)>\n\n" + "<!ELEMENT " + entity + " (" + name + ", "
				+ implied + "*)>\n" + "<!ELEMENT " + name + pcdata
				+ "<!ELEMENT " + implied + pcdata + "\n" + "<!ELEMENT "
				+ person + " (" + name + ", " + implied + "*)>\n"
				+ "<!ELEMENT " + behavior + " (" + name + ", " + implied
				+ "*)>\n" + "<!ELEMENT " + event + " (" + name + ", "
				+ longName + "?, " + sourceText + "?, " + comment + "?, "
				+ isLinked + ", " + isDisjunctive + ", " + isRepeatable + ", "
				+ isGeneralization + ", " + isInstantiated + "?, "
				+ isSummarized + ", " + eventFrame + "?, " + implies + "*, "
				+ generalizesTo + "*, " + summarizes + "*)>\n" + "<!ELEMENT "
				+ longName + pcdata + "<!ELEMENT " + sourceText + pcdata
				+ "<!ELEMENT " + comment + pcdata + "<!ELEMENT " + isLinked
				+ pcdata + "<!ELEMENT " + isDisjunctive + pcdata + "<!ELEMENT "
				+ isRepeatable + pcdata + "<!ELEMENT " + isGeneralization
				+ pcdata + "<!ELEMENT " + isInstantiated + pcdata
				+ "<!ELEMENT " + isSummarized + pcdata + "<!ELEMENT "
				+ eventFrame + " (" + agent + "?, " + act + "?, " + object
				+ "?, " + instrument + "?, " + alignment + "?, " + setting
				+ "?, " + product + "?, " + beneficiary + "?)>\n"
				+ "<!ELEMENT " + agent + pcdata + "<!ELEMENT " + act + pcdata
				+ "<!ELEMENT " + object + pcdata + "<!ELEMENT " + instrument
				+ pcdata + "<!ELEMENT " + alignment + pcdata + "<!ELEMENT "
				+ setting + pcdata + "<!ELEMENT " + product + pcdata
				+ "<!ELEMENT " + beneficiary + pcdata + "<!ELEMENT " + implies
				+ " (" + antecedent + ", " + depletesAntecedent + ", "
				+ commutesWithAntecedent + ")>\n" + "<!ELEMENT " + antecedent
				+ pcdata + "<!ELEMENT " + depletesAntecedent + pcdata
				+ "<!ELEMENT " + commutesWithAntecedent + pcdata + "\n"
				+ "<!ELEMENT " + generalizesTo + pcdata + "<!ELEMENT "
				+ summarizes + pcdata + "<!ELEMENT " + sequence + " ("
				+ recordedEvent + ")>\n" + "<!ELEMENT " + recordedEvent
				+ pcdata + "<!ELEMENT " + linkingHistory + pcdata + "]\n>\n\n";
		// Add first line of actual XML text.
		data = data + "<" + episode + ">\n";
		// Deal with entities.
		if (Ethno.entities.size() > 0) {
			data = data + "\n";
			if (!generalizedModel) {
				for (int i = 0; i < Ethno.entities.size(); i++) {
					y = (Percept) Ethno.entities.elementAt(i);
					data = data + open(entity) + "\n";
					data = data + y.toXML(); // Uses toXML in Percept.
					data = data + close(entity) + "\n";
				}
			}
		}
		// Deal with persons.
		if (Ethno.people.size() > 0) {
			data = data + "\n";
			if (!generalizedModel) {
				for (int i = 0; i < Ethno.people.size(); i++) {
					y = (Percept) Ethno.people.elementAt(i);
					data = data + open(person) + "\n";
					data = data + y.toXML(); // Uses toXML in Percept.
					data = data + close(person) + "\n";
				}
			}
		}
		// Deal with acts.
		if (Ethno.actions.size() > 0) {
			data = data + "\n";
			if (!generalizedModel) {
				for (int i = 0; i < Ethno.actions.size(); i++) {
					y = (Percept) Ethno.actions.elementAt(i);
					data = data + open(behavior) + "\n";
					data = data + y.toXML(); // Uses toXML in Percept.
					data = data + close(behavior) + "\n";
				}
			}
		}
		// Deal with deeds.
		data = data + "\n";
		for (int i = 0; i < Ethno.deeds.size(); i++) {
			x = (Deed) Ethno.deeds.elementAt(i);
			if (!generalizedModel || (generalizedModel & x.isGeneralization)) {
				data = data + open(event) + "\n";
				data = data + x.toXML(generalizedModel); // Uses toXML in
				// Deed.
				data = data + close(event) + "\n";
			}
		}
		// Deal with sequence.
		if (!generalizedModel) {
			data = data + open(sequence) + "\n";
			for (int i = 0; i < Ethno.defineSequenceCard.sequenceDisplay
				.getItemCount(); i++) {
				data =
					data + open(recordedEvent)
						+ Ethno.defineSequenceCard.sequenceDisplay.getItem(i)
						+ close(recordedEvent) + "\n";
			}
			data = data + close(sequence) + "\n";
		}
		if (!generalizedModel) {
			// Include linking history.
			data = data + open(linkingHistory) + "\n";
			data = data + "<![CDATA[" + Ethno.linkingHistory + "]]>\n";
			data = data + close(linkingHistory) + "\n";
			// Include narrative text.
			data = data + open(narrative) + "\n";
			data = data + "<![CDATA[" + Ethno.narrative + "]]>\n";
			data = data + close(narrative) + "\n";
		}
		data = data + close(episode) + "\n";
		return data;
	} // End exportXML.

	/** Parse a string of XML to re-create the model that the string represents. */
	public void importingXML() {
		Deed aDeed;
		Percept aPercept;
		int last, index;
		String elementText, eventText, nameText;
		// Line separator varies across Java implementations:
		String temp = data.replace('\r', '\n');
		data = temp;
		// Jump past doctype.
		data = data.substring(data.indexOf(open(episode)));
		// Incorporate zero or more entities.
		while (data.indexOf(open(entity)) != -1) {
			// Get text for name and implied entities of this entity.
			data = data.substring(data.indexOf(open(name)));
			last = data.indexOf(close(entity));
			elementText = data.substring(0, last);
			aPercept = new Percept();
			// Parse the text to fill out the percept.
			aPercept.fromXMLString(elementText);
			index = Ethno.entities.insertAlphabetically(aPercept);
			if (index < 0) {
				elementError(Ethno.entities, aPercept);
			}
			data = data.substring(last);
		}
		// Incorporate zero or more persons.
		while (data.indexOf(open(person)) != -1) {
			// Get text for name and implied identities of this identity.
			data = data.substring(data.indexOf(open(name)));
			last = data.indexOf(close(person));
			elementText = data.substring(0, last);
			aPercept = new Percept();
			// Parse the text to fill out the percept.
			aPercept.fromXMLString(elementText);
			index = Ethno.people.insertAlphabetically(aPercept);
			if (index < 0) {
				elementError(Ethno.people, aPercept);
			}
			data = data.substring(last);
		}
		// Incorporate zero or more acts.
		while (data.indexOf(open(behavior)) != -1) {
			// Get text for name and implied behaviors of this behavior.
			data = data.substring(data.indexOf(open(name)));
			last = data.indexOf(close(behavior));
			elementText = data.substring(0, last);
			aPercept = new Percept();
			// Parse the text to fill out the percept.
			aPercept.fromXMLString(elementText);
			index = Ethno.actions.insertAlphabetically(aPercept);
			if (index < 0) {
				elementError(Ethno.actions, aPercept);
			}
			data = data.substring(last);
		}
		// Incorporate one or more deeds.
		if (data.indexOf(open(event)) == -1) {
			Ethno.reportPage.results.append(
				Ethno.interfaceTexts.getString("noEvents") + "\n");
			return;
		}
		while (data.indexOf(open(event)) != -1) {
			// Get text describing this deed.
			data = data.substring(data.indexOf(open(name)));
			last = data.indexOf(close(event));
			eventText = data.substring(0, last);
			aDeed = new Deed();
			// Parse the text to specify the event.
			aDeed.fromXMLString(eventText);
			if (Ethno.deeds.insertAlphabetically(aDeed) < 0) {
				eventError(Ethno.deeds, aDeed);
			}
			data = data.substring(last);
		}
		// Restore the sequence.
		Ethno.defineSequenceCard.sequenceDisplay.removeAll();
		// Lop off <SEQUENCE>
		data =
			data.substring(data.indexOf(open(sequence))
				+ open(sequence).length());
		while (data.indexOf(open(recordedEvent)) != -1) {
			// Lop off <RECORDED_EVENT> and preceding characters.
			data =
				data.substring(data.indexOf(open(recordedEvent))
					+ open(recordedEvent).length());
			// Get the deed namet.
			nameText = data.substring(0, data.indexOf(close(recordedEvent)));
			index = Ethno.deeds.findPositionOfElement(nameText);
			if (index < 0) {
				ImportExportCard.importingMessage =
					Ethno.interfaceTexts.getString("importError");
				return;
			} else {
				Ethno.sequence.addElement(Ethno.deeds.elementAt(index));
				Ethno.defineSequenceCard.sequenceDisplay.add(nameText);
			}
		}
		// Get linking history and narrative, if not generalized model.
		if (!Ethno.deeds.isGeneralizedModelOnly()) {
			// Lop off <![CDATA[]]> and preceding characters.
			data = data.substring(data.indexOf("<![CDATA[") + 9);
			// Get the text
			Ethno.linkingHistory = data.substring(0, data.indexOf("]]>"));
			Ethno.defineLinksCard.elicitationLog.setText(Ethno.linkingHistory);
			// Get narrative.
			// Lop off <![CDATA[]]> and preceding characters.
			data = data.substring(data.indexOf("<![CDATA[") + 9);
			// Get the text
			Ethno.narrative = data.substring(0, data.indexOf("]]>"));
			Ethno.defineSequenceCard.narrativeTextArea.setText(Ethno.narrative);
		}
		// Set tiers.
		Ethno.deeds.topoSort();
		Ethno.controls.rebuildEventsChoice();
		Ethno.controls.rebuildElementChoices();
		Ethno.controls.redisplayControlArea(1);
	} // End importingXML.

	/** Try to repair duplicate element name. */
	private void elementError(PerceptList L, Percept y) {
		Ethno.reportPage.results.append(
			"Duplicate element: " + y.shortName + "\n");
		// Make the name a non-duplicate.
		y.shortName = y.shortName + "~IMPORTED~";
		if (L.insertAlphabetically(y) < 0) {
			Ethno.reportPage.results.append(
				"STILL ERROR " + y.shortName + "\n");
		}
	} // End elementError.

	/** Try to repair duplicate event name. */
	private void eventError(PerceptList L, Deed x) {
		Ethno.reportPage.results.append(
			"Duplicate event: " + x.shortName + "\n");
		// Make the name a non-duplicate.
		x.shortName = x.shortName + "~IMPORTED~";
		if (L.insertAlphabetically(x) < 0) {
			Ethno.reportPage.results.append(
				"STILL ERROR " + x.shortName + "\n");
		}
	} // End eventError.

	static String open(String textPart) {
		return "<" + textPart + ">";
	}

	static String close(String textPart) {
		return "</" + textPart + ">";
	}

} // End class SavedData.
