
import java.awt.Checkbox;
import java.awt.CheckboxGroup;
import java.awt.Color;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import java.awt.Insets;
import java.awt.Label;
import java.awt.Panel;
import java.awt.TextArea;
import java.awt.TextField;
import java.awt.event.ActionEvent;
import java.awt.event.MouseEvent;
import java.util.Vector;

/** Page for displaying one event. */
public class ShowDeedCard extends Panel {

	int indexToDeed;

	Percept categoryItem;

	Panel textsPanel = new Panel();

	Panel linksPanel = new Panel();

	Panel eventFramePanel = new Panel();

	Label abbreviationTitle = new Label();

	Label descriptionTitle = new Label();

	Label quoteTitle = new Label();

	Label commentTitle = new Label();

	Label prerequisiteTitle = new Label();

	Label consequencesTitle = new Label();

	Label summarizationTitle = new Label();

	Label generalizationTitle = new Label();

	Label linkedReportLabel = new Label();

	TextField showAbbreviation = new TextField();

	TextArea eventDescription = new TextArea("", 3, 25,
		TextArea.SCROLLBARS_VERTICAL_ONLY);

	TextArea quote = new TextArea("", 3, 25, TextArea.SCROLLBARS_VERTICAL_ONLY);

	TextArea comment = new TextArea("", 3, 25,
		TextArea.SCROLLBARS_VERTICAL_ONLY);

	java.awt.List prerequisiteListing = new java.awt.List();

	java.awt.List consequencesListing = new java.awt.List();

	java.awt.List summaryListing = new java.awt.List();

	java.awt.List generalizationListing = new java.awt.List();

	java.awt.List[] eventFrameListing = new java.awt.List[9];

	Checkbox disjunctiveCheckbox = new Checkbox();

	Checkbox repeatableCheckbox = new Checkbox();

	Checkbox[] eventFrameCheckbox = new Checkbox[9];

	CheckboxGroup eventFrameGroup = new CheckboxGroup();

	GridBagLayout pageLayout = new GridBagLayout();

	GridBagLayout textsPanelLayout = new GridBagLayout();

	GridBagLayout linksPanelLayout = new GridBagLayout();

	GridLayout eventFrameLayout = new GridLayout();

	public ShowDeedCard() {
		try {
			jbInit();
		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}

	private void jbInit() throws Exception {
		this.setLayout(pageLayout);
		disjunctiveCheckbox.setBackground(Color.white);
		repeatableCheckbox.setBackground(Color.white);
		descriptionTitle.setBackground(Color.white);
		abbreviationTitle.setBackground(Color.white);
		commentTitle.setBackground(Color.white);
		prerequisiteTitle.setBackground(Color.white);
		consequencesTitle.setBackground(Color.white);
		summaryListing.setBackground(Color.white);
		generalizationTitle.setBackground(Color.white);
		generalizationListing.setBackground(Color.white);
		textsPanel.setBackground(Color.white);
		linksPanel.setBackground(Color.white);
		summarizationTitle.setBackground(Color.white);
		prerequisiteListing.setBackground(Color.white);
		consequencesListing.setBackground(Color.white);
		eventFramePanel.setBackground(Color.white);
		textsPanel.setLayout(textsPanelLayout);

		abbreviationTitle.setText(Ethno.interfaceTexts
			.getString("abbreviationTitleText"));
		descriptionTitle.setText(Ethno.interfaceTexts
			.getString("descriptionTitleText"));
		quoteTitle.setText(Ethno.interfaceTexts.getString("quoteTitleText"));
		commentTitle
			.setText(Ethno.interfaceTexts.getString("commentTitleText"));
		prerequisiteTitle.setText(Ethno.interfaceTexts
			.getString("prerequisiteTitleText"));
		consequencesTitle.setText(Ethno.interfaceTexts
			.getString("consequenceTitleText"));
		summarizationTitle.setText(Ethno.interfaceTexts
			.getString("summarizationTitleText"));
		generalizationTitle.setText(Ethno.interfaceTexts
			.getString("generalizationTitleText"));
		disjunctiveCheckbox.setLabel(Ethno.interfaceTexts
			.getString("disjunctiveBoxText"));
		repeatableCheckbox.setLabel(Ethno.interfaceTexts
			.getString("repeatableBoxText"));
		linkedReportLabel.setText(Ethno.interfaceTexts.getString("linkedText")
			+ Ethno.interfaceTexts.getString("colonSpace") + false);

		eventFrameLayout.setColumns(2);
		this.add(textsPanel, new SetOfGridBagConstraints(0, 0, 1, 1, 1.0, 1.0,
			SetOfGridBagConstraints.CENTER, SetOfGridBagConstraints.BOTH,
			new Insets(0, 0, 0, 5), 0, 0));
		this.add(linksPanel, new SetOfGridBagConstraints(1, 0, 1, 1, 1.0, 1.0,
			SetOfGridBagConstraints.CENTER, SetOfGridBagConstraints.BOTH,
			new Insets(0, 5, 0, 5), 0, 0));
		this.add(eventFramePanel, new SetOfGridBagConstraints(2, 0, 1, 1, 1.0,
			1.0, SetOfGridBagConstraints.CENTER, SetOfGridBagConstraints.BOTH,
			new Insets(0, 5, 0, 0), 0, 0));

		// Left side.
		eventDescription.setFont(new java.awt.Font("Dialog", 0, 10));
		quote.setFont(new java.awt.Font("Dialog", 0, 10));
		comment.setFont(new java.awt.Font("Dialog", 0, 10));
		textsPanel.add(abbreviationTitle, new SetOfGridBagConstraints(0, 0, 1,
			1, 1.0, 1.0, SetOfGridBagConstraints.SOUTH,
			SetOfGridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
		textsPanel.add(showAbbreviation, new SetOfGridBagConstraints(0, 1, 1,
			1, 1.0, 1.0, SetOfGridBagConstraints.NORTH,
			SetOfGridBagConstraints.HORIZONTAL, new Insets(0, 0, 0, 0), 0, 0));
		textsPanel.add(descriptionTitle, new SetOfGridBagConstraints(0, 2, 1,
			1, 1.0, 1.0, SetOfGridBagConstraints.SOUTH,
			SetOfGridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
		textsPanel.add(eventDescription, new SetOfGridBagConstraints(0, 3, 1,
			1, 1.0, 0.0, SetOfGridBagConstraints.CENTER,
			SetOfGridBagConstraints.BOTH, new Insets(0, 0, 0, 0), 0, 0));
		textsPanel.add(quoteTitle, new SetOfGridBagConstraints(0, 4, 1, 1, 1.0,
			1.0, SetOfGridBagConstraints.SOUTH, SetOfGridBagConstraints.NONE,
			new Insets(0, 0, 0, 0), 0, 0));
		textsPanel.add(quote, new SetOfGridBagConstraints(0, 5, 1, 1, 1.0, 0.0,
			SetOfGridBagConstraints.CENTER, SetOfGridBagConstraints.BOTH,
			new Insets(0, 0, 0, 0), 0, 0));
		textsPanel.add(commentTitle, new SetOfGridBagConstraints(0, 6, 1, 1,
			1.0, 1.0, SetOfGridBagConstraints.SOUTH,
			SetOfGridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));
		textsPanel.add(comment, new SetOfGridBagConstraints(0, 7, 1, 1, 1.0,
			0.0, SetOfGridBagConstraints.CENTER, SetOfGridBagConstraints.BOTH,
			new Insets(0, 0, 0, 0), 0, 0));

		// Center.
		linksPanel.setLayout(linksPanelLayout);
		linksPanel.add(prerequisiteTitle, new SetOfGridBagConstraints(0, 1, 1,
			1, 1.0, 1.0, GridBagConstraints.SOUTH, GridBagConstraints.NONE,
			new Insets(0, 0, 0, 0), 0, 0));
		linksPanel.add(prerequisiteListing, new SetOfGridBagConstraints(0, 2,
			1, 1, 1.0, 2.0, GridBagConstraints.CENTER, GridBagConstraints.BOTH,
			new Insets(0, 0, 0, 0), 0, 0));
		linksPanel.add(consequencesTitle, new SetOfGridBagConstraints(0, 3, 1,
			1, 0.0, 0.0, GridBagConstraints.SOUTH, GridBagConstraints.NONE,
			new Insets(0, 0, 0, 0), 0, 0));
		linksPanel.add(consequencesListing, new SetOfGridBagConstraints(0, 4,
			1, 1, 1.0, 1.0, GridBagConstraints.CENTER, GridBagConstraints.BOTH,
			new Insets(0, 0, 0, 0), 0, 0));
		linksPanel.add(summarizationTitle, new SetOfGridBagConstraints(0, 5, 1,
			1, 1.0, 1.0, GridBagConstraints.SOUTH, GridBagConstraints.NONE,
			new Insets(0, 0, 0, 0), 0, 0));
		linksPanel.add(summaryListing, new SetOfGridBagConstraints(0, 6, 1, 1,
			1.0, 2.0, GridBagConstraints.CENTER, GridBagConstraints.BOTH,
			new Insets(0, 0, 0, 0), 0, 0));
		linksPanel.add(generalizationTitle, new SetOfGridBagConstraints(0, 7,
			1, 1, 1.0, 1.0, GridBagConstraints.SOUTH, GridBagConstraints.NONE,
			new Insets(0, 0, 0, 0), 0, 0));
		linksPanel.add(generalizationListing, new SetOfGridBagConstraints(0, 8,
			1, 1, 1.0, 2.0, GridBagConstraints.CENTER, GridBagConstraints.BOTH,
			new Insets(0, 0, 0, 0), 0, 0));
		linksPanel.add(disjunctiveCheckbox, new SetOfGridBagConstraints(0, 9,
			1, 1, 1.0, 1.0, GridBagConstraints.WEST, GridBagConstraints.NONE,
			new Insets(0, 10, 0, 0), 0, 0));
		linksPanel.add(repeatableCheckbox, new SetOfGridBagConstraints(0, 10,
			1, 1, 1.0, 1.0, GridBagConstraints.WEST, GridBagConstraints.NONE,
			new Insets(0, 10, 0, 0), 0, 0));
		linksPanel.add(linkedReportLabel, new SetOfGridBagConstraints(0, 11, 1,
			1, 0.0, 0.0, GridBagConstraints.SOUTH, GridBagConstraints.NONE,
			new Insets(0, 0, 0, 0), 0, 0));

		// Right side.
		eventFrameLayout.setRows(0);
		eventFramePanel.setLayout(eventFrameLayout);
		for (int i = 0; i < Ethno.eventFrameName.length - 1; i++) {
			String boxLabel = Ethno.eventFrameName[i];
			eventFrameCheckbox[i] =
				new Checkbox(boxLabel, eventFrameGroup, i == 0);
			eventFrameCheckbox[i].setBackground(Color.cyan);
			eventFramePanel.add(eventFrameCheckbox[i]);
			eventFrameListing[i] = new java.awt.List();
			eventFrameListing[i].setBackground(Color.white);
			eventFramePanel.add(eventFrameListing[i]);
		}
		// The ninth radio button allows others to be turned off.
		eventFrameCheckbox[8] =
			new Checkbox(Ethno.eventFrameName[8], eventFrameGroup, true);
		eventFrameCheckbox[8].setVisible(false);
		linksPanel.add(eventFrameCheckbox[8], new SetOfGridBagConstraints(0, 9,
			1, 1, 0.0, 0.0, SetOfGridBagConstraints.CENTER,
			SetOfGridBagConstraints.NONE, new Insets(0, 0, 0, 0), 0, 0));

		prerequisiteListing
			.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent e) {
					goToDeed(prerequisiteListing.getSelectedItem());
				}
			});
		consequencesListing
			.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent e) {
					goToDeed(consequencesListing.getSelectedItem());
				}
			});
		generalizationListing
			.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent e) {
					goToDeed(generalizationListing.getSelectedItem());
				}
			});
		summaryListing.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(ActionEvent e) {
				goToDeed(summaryListing.getSelectedItem());
			}
		});
		eventFrameListing[0]
			.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent e) {
					deleteElement(0, e);
				}
			});
		eventFrameListing[1]
			.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent e) {
					deleteElement(1, e);
				}
			});
		eventFrameListing[2]
			.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent e) {
					deleteElement(2, e);
				}
			});
		eventFrameListing[3]
			.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent e) {
					deleteElement(3, e);
				}
			});
		eventFrameListing[4]
			.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent e) {
					deleteElement(4, e);
				}
			});
		eventFrameListing[5]
			.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent e) {
					deleteElement(5, e);
				}
			});
		eventFrameListing[6]
			.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent e) {
					deleteElement(6, e);
				}
			});
		eventFrameListing[7]
			.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent e) {
					deleteElement(7, e);
				}
			});
	} // End jbInit.

	/** Remove a double-clicked element from the frame for the event. */
	void deleteElement(int frameSlot, ActionEvent e) {
		String theLine, thisLine;
		theLine = e.getActionCommand();
		Vector vectorOfStrings = new Vector();
		for (int j = 0; j < eventFrameListing[frameSlot].getItemCount(); j++) {
			vectorOfStrings.addElement(eventFrameListing[frameSlot].getItem(j));
		}
		eventFrameListing[frameSlot].removeAll();
		for (int j = 0; j < vectorOfStrings.size(); j++) {
			thisLine = (String) vectorOfStrings.elementAt(j);
			if (!thisLine.equals(theLine)) {
				eventFrameListing[frameSlot].add(thisLine);
			}
		}
		Ethno.controls.dispatchEvent(new MouseEvent(Ethno.controls,
			MouseEvent.MOUSE_ENTERED, 0, 0, 0, 0, 0, false));
	} // End deleteElement.

	/** Display the available information about an event. */
	public void fetchData(String smallName) {
		Deed theDeed, aDeed;
		Vector v;
		Percept p;
		Relation r;
		Ethno.displayPanel.invalidate();
		// Card must be showing for changes to work:
		Ethno.card.show(Ethno.displayPanel, Ethno.SHOW_DEED);
		Ethno.displayPanel.validate();
		// Get the event and set indexToDeed.
		theDeed = (Deed) Ethno.deeds.elementAt(0); // Initialize to stop
													// compiler complaint.
		for (indexToDeed = 0; indexToDeed < Ethno.deeds.size(); indexToDeed++) {
			theDeed = (Deed) Ethno.deeds.elementAt(indexToDeed);
			if (smallName.equals(theDeed.shortName)) {
				break;
			}
		}
		this.showAbbreviation.setText(smallName);
		this.eventDescription.setText(theDeed.verboseEventName);
		this.quote.setText(theDeed.sourceText);
		this.comment.setText(theDeed.comment);
		// Links.
		prerequisiteListing.invalidate();
		prerequisiteListing.removeAll();
		for (int i = 0; i < theDeed.implications.size(); i++) {
			r = (Relation) theDeed.implications.elementAt(i);
			prerequisiteListing.add(r.implicated);
		}
		consequencesListing.invalidate();
		consequencesListing.removeAll();
		for (int j = 0; j < Ethno.deeds.size(); j++) {
			aDeed = (Deed) Ethno.deeds.elementAt(j);
			for (int k = 0; k < aDeed.implications.size(); k++) {
				r = (Relation) aDeed.implications.elementAt(k);
				if (r.implicated.equalsIgnoreCase(theDeed.shortName)) {
					consequencesListing.add(aDeed.shortName);
				}
			}
		}
		summaryListing.invalidate();
		summaryListing.removeAll();
		summarizationTitle.setText(Ethno.interfaceTexts
			.getString("summarizationTitleText"));
		for (int i = 0; i < theDeed.summarizedActions.size(); i++) {
			r = (Relation) theDeed.summarizedActions.elementAt(i);
			summaryListing.add(r.implicated);
		}
		generalizationListing.invalidate();
		generalizationListing.removeAll();
		if (theDeed.isGeneralization) {
			// Use generalizationListing for instantiations if the event is a
			// generalization.
			Vector instantiations = theDeed.getInstantiators();
			for (int i = 0; i < instantiations.size(); i++) {
				generalizationListing
					.add(((Deed) instantiations.elementAt(i)).shortName);
			}
			if (instantiations.size() == 0) {
				generalizationTitle.setText(Ethno.interfaceTexts
					.getString("noInstantiationTitleText"));
			} else {
				generalizationTitle.setText(Ethno.interfaceTexts
					.getString("generalizesTitleText"));
			}
		} else {
			generalizationTitle.setText(Ethno.interfaceTexts
				.getString("generalizationTitleText"));
			for (int i = 0; i < theDeed.generalizations.size(); i++) {
				r = (Relation) theDeed.generalizations.elementAt(i);
				generalizationListing.add(r.implicated);
			}
		}
		disjunctiveCheckbox.setState(theDeed.isDisjunctive);
		repeatableCheckbox.setState(theDeed.isRepeatable);
		linkedReportLabel.setText(Ethno.interfaceTexts.getString("linkedText")
			+ Ethno.interfaceTexts.getString("space") + theDeed.isLinked);
		// Add Event Frame associations.
		for (int i = 0; i < 8; i++) {
			eventFrameListing[i].invalidate();
			eventFrameListing[i].removeAll();
			v = theDeed.eventFrame[i];
			for (int j = 0; j < v.size(); j++) {
				p = (Percept) v.elementAt(j);
				eventFrameListing[i].add(p.shortName);
			}
		}
		this.validate();
	} // End fetchData.

	/** Returns an index to the Event Frame box that is checked. */
	public int getCheckedCategoryInEventFrame() {
		for (int i = 0; i < 8; i++) {
			if (eventFrameCheckbox[i].getState()) { return i; }
		}
		return -1;
	}

	void goToDeed(String nameOfDesiredDeed) {
		Ethno.controls.incorporateDeedOrPerceptChanges();
		Ethno.showDeedCard.fetchData(nameOfDesiredDeed);
	}

}