
import java.awt.BorderLayout;
import java.awt.Button;
import java.awt.Checkbox;
import java.awt.CheckboxGroup;
import java.awt.Choice;
import java.awt.Color;
import java.awt.FlowLayout;
import java.awt.Frame;
import java.awt.GridBagConstraints;
import java.awt.GridBagLayout;
import java.awt.GridLayout;
import java.awt.Insets;
import java.awt.Label;
import java.awt.Panel;
import java.awt.TextField;
import java.awt.event.ActionEvent;
import java.awt.event.FocusEvent;
import java.awt.event.ItemEvent;
import java.util.Vector;

/** Page for displaying an element - entity, person, or action. */
public class ShowPerceptCard extends Panel {

	static public int currentElementType;

	boolean[] wantFocusElementInFrameCategory, wantOtherElementInFrameCategory;

	int indexToElement;

	Panel inputsPanel = new Panel();

	Panel abstractionArea = new Panel();

	Panel expansionArea = new Panel();

	Panel reportsPanel = new Panel();

	Panel eventsPanel = new Panel();

	Panel eventsContainingPanel = new Panel();

	Panel associationsPanel = new Panel();

	Panel actionsPanel = new Panel();

	Panel entitiesPanel = new Panel();

	Panel peoplePanel = new Panel();

	Label nameLabel = new Label();

	Label expansionTitle = new Label();

	Label containingEventsLabel = new Label();

	Label actionsLabel = new Label();

	Label entitiesLabel = new Label();

	Label peopleLabel = new Label();

	TextField nameTextBox = new TextField();

	java.awt.List containingEvents = new java.awt.List();

	java.awt.List abstractionsList = new java.awt.List();

	java.awt.List concreteFormsList = new java.awt.List();

	java.awt.List actionAssociations = new java.awt.List();

	java.awt.List entityAssociations = new java.awt.List();

	java.awt.List personAssociations = new java.awt.List();

	Choice chooseGeneralizationMenu = new Choice();

	Button returnButton = new Button();

	Button cutButton = new Button();

	Button constraintsButton = new Button();

	Button computeButton = new Button();

	Checkbox generalizeCheckbox = new Checkbox();

	Checkbox generalizedEventsCheckbox = new Checkbox();

	Checkbox concreteEventsCheckbox = new Checkbox();

	CheckboxGroup typeOfEventsCheckboxGroup = new CheckboxGroup();

	BorderLayout pageLayout = new BorderLayout();

	GridBagLayout inputsPanelLayout = new GridBagLayout();

	BorderLayout abstractionAreaLayout = new BorderLayout();

	BorderLayout expansionAreaLayout = new BorderLayout();

	BorderLayout reportsPanelLayout = new BorderLayout();

	BorderLayout eventsPanelLayout = new BorderLayout();

	GridLayout associationsPanelLayout = new GridLayout(1, 3, 5, 5);

	BorderLayout actionsPanelLayout = new BorderLayout();

	BorderLayout entitiesPanelLayout = new BorderLayout();

	BorderLayout peoplePanelLayout = new BorderLayout();

	FlowLayout eventsContainingPanelLayout = new FlowLayout();

	public ShowPerceptCard() {
		try {
			jbInit();
		} catch (Exception ex) {
			ex.printStackTrace();
		}
	}

	private void jbInit() throws Exception {
		this.setBackground(Color.white);
		inputsPanel.setBackground(Color.white);
		nameLabel.setBackground(Color.white);
		abstractionArea.setBackground(Color.white);
		abstractionsList.setBackground(Color.white);
		expansionArea.setBackground(Color.white);
		expansionTitle.setBackground(Color.white);
		concreteFormsList.setBackground(Color.white);
		generalizeCheckbox.setBackground(Color.white);
		reportsPanel.setBackground(Color.white);
		eventsPanel.setBackground(Color.white);
		eventsContainingPanel.setBackground(Color.white);
		concreteEventsCheckbox.setBackground(Color.white);
		generalizedEventsCheckbox.setBackground(Color.white);
		containingEventsLabel.setBackground(Color.white);
		associationsPanel.setBackground(Color.white);
		actionsPanel.setBackground(Color.white);
		actionsLabel.setBackground(Color.white);
		actionAssociations.setBackground(Color.white);
		entitiesPanel.setBackground(Color.white);
		entitiesLabel.setBackground(Color.white);
		entityAssociations.setBackground(Color.white);
		peoplePanel.setBackground(Color.white);
		personAssociations.setBackground(Color.white);
		peopleLabel.setBackground(Color.white);
		containingEvents.setBackground(Color.white);

		this.setLayout(pageLayout);
		pageLayout.setHgap(5);
		inputsPanel.setLayout(inputsPanelLayout);
		abstractionArea.setLayout(abstractionAreaLayout);
		expansionArea.setLayout(expansionAreaLayout);
		associationsPanel.setLayout(associationsPanelLayout);
		actionsPanel.setLayout(actionsPanelLayout);
		reportsPanel.setLayout(reportsPanelLayout);
		eventsPanel.setLayout(eventsPanelLayout);
		entitiesPanel.setLayout(entitiesPanelLayout);
		peoplePanel.setLayout(peoplePanelLayout);
		eventsContainingPanel.setLayout(eventsContainingPanelLayout);

		returnButton.setLabel(Ethno.interfaceTexts
			.getString("returnToEventText"));
		nameLabel.setText(Ethno.elementName[currentElementType]);
		computeButton.setLabel(Ethno.interfaceTexts.getString("computeText"));
		constraintsButton.setLabel(Ethno.interfaceTexts
			.getString("constraintsText"));
		cutButton
			.setLabel(Ethno.interfaceTexts.getString("cutAbstractionText"));
		generalizeCheckbox.setLabel(Ethno.interfaceTexts
			.getString("generalizeText"));
		expansionTitle.setText(Ethno.interfaceTexts.getString("expansionText"));
		generalizedEventsCheckbox.setLabel(Ethno.interfaceTexts
			.getString("generalizedEvents"));
		concreteEventsCheckbox.setLabel(Ethno.interfaceTexts
			.getString("concreteEvents"));
		containingEventsLabel.setText(Ethno.interfaceTexts
			.getString("eventsContainingLabelText"));
		actionsLabel.setText(Ethno.interfaceTexts
			.getString("actionAssociationsLabelText"));
		entitiesLabel.setText(Ethno.interfaceTexts
			.getString("entityAssociationsLabelText"));
		peopleLabel.setText(Ethno.interfaceTexts
			.getString("personAssociationsLabelText"));

		nameTextBox.setColumns(20);
		expansionTitle.setAlignment(Label.CENTER);
		containingEventsLabel.setAlignment(Label.CENTER);
		actionsLabel.setAlignment(Label.CENTER);
		entitiesLabel.setAlignment(Label.CENTER);
		peopleLabel.setAlignment(Label.CENTER);
		concreteEventsCheckbox.setCheckboxGroup(typeOfEventsCheckboxGroup);
		generalizedEventsCheckbox.setCheckboxGroup(typeOfEventsCheckboxGroup);
		typeOfEventsCheckboxGroup.setSelectedCheckbox(concreteEventsCheckbox);
		if (Ethno.deeds.isGeneralizedModel()) {
			generalizedEventsCheckbox.setEnabled(true);
		} else {
			generalizedEventsCheckbox.setEnabled(false);
		}

		this.add(inputsPanel, BorderLayout.WEST);
		this.add(reportsPanel, BorderLayout.CENTER);
		inputsPanel.add(returnButton, new SetOfGridBagConstraints(0, 0, 1, 1,
			0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.NONE,
			new Insets(0, 0, 0, 0), 0, 0));
		inputsPanel.add(nameLabel, new SetOfGridBagConstraints(0, 1, 1, 1, 0.0,
			0.0, GridBagConstraints.CENTER, GridBagConstraints.NONE,
			new Insets(10, 0, 0, 0), 0, 0));
		inputsPanel.add(nameTextBox, new SetOfGridBagConstraints(0, 2, 1, 1,
			0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.NONE,
			new Insets(0, 0, 0, 0), 0, 0));
		inputsPanel.add(abstractionArea, new SetOfGridBagConstraints(0, 3, 1,
			1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.NONE,
			new Insets(15, 0, 0, 0), 0, 0));
		abstractionArea.add(chooseGeneralizationMenu, BorderLayout.NORTH);
		abstractionArea.add(abstractionsList, BorderLayout.CENTER);
		abstractionArea.add(cutButton, BorderLayout.SOUTH);
		inputsPanel.add(expansionArea, new SetOfGridBagConstraints(0, 4, 1, 1,
			0.0, 0.0, GridBagConstraints.SOUTH, GridBagConstraints.BOTH,
			new Insets(10, 0, 0, 0), 0, 0));
		expansionArea.add(expansionTitle, BorderLayout.NORTH);
		expansionArea.add(concreteFormsList, BorderLayout.CENTER);
		inputsPanel.add(generalizeCheckbox, new SetOfGridBagConstraints(0, 5,
			1, 1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.NONE,
			new Insets(25, 0, 0, 0), 0, 0));
		inputsPanel.add(constraintsButton, new SetOfGridBagConstraints(0, 6, 1,
			1, 0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.NONE,
			new Insets(5, 0, 5, 0), 0, 0));
		inputsPanel.add(computeButton, new SetOfGridBagConstraints(0, 7, 1, 1,
			0.0, 0.0, GridBagConstraints.CENTER, GridBagConstraints.NONE,
			new Insets(5, 0, 0, 0), 0, 0));
		reportsPanel.add(eventsPanel, BorderLayout.NORTH);
		eventsPanel.add(containingEvents, BorderLayout.CENTER);
		eventsPanel.add(eventsContainingPanel, BorderLayout.NORTH);
		eventsContainingPanel.add(concreteEventsCheckbox, null);
		eventsContainingPanel.add(generalizedEventsCheckbox, null);
		eventsContainingPanel.add(containingEventsLabel, null);
		reportsPanel.add(associationsPanel, BorderLayout.CENTER);
		associationsPanel.add(actionsPanel, null);
		actionsPanel.add(actionsLabel, BorderLayout.NORTH);
		actionsPanel.add(actionAssociations, BorderLayout.CENTER);
		associationsPanel.add(entitiesPanel, null);
		entitiesPanel.add(entitiesLabel, BorderLayout.NORTH);
		entitiesPanel.add(entityAssociations, BorderLayout.CENTER);
		associationsPanel.add(peoplePanel, null);
		peoplePanel.add(peopleLabel, BorderLayout.NORTH);
		peoplePanel.add(personAssociations, BorderLayout.CENTER);
		wantFocusElementInFrameCategory = new boolean[8];
		wantOtherElementInFrameCategory = new boolean[8];
		for (int i = 0; i < 8; i++) {
			wantFocusElementInFrameCategory[i] = true;
			wantOtherElementInFrameCategory[i] = true;
		}
		returnButton.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(ActionEvent e) {
				returnToDeed();
			}
		});
		nameTextBox.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(ActionEvent e) {
				incorporateNaming();
			}
		});
		nameTextBox.addFocusListener(new java.awt.event.FocusAdapter() {
			public void focusLost(FocusEvent e) {
				if (!nameTextBox.getText().equalsIgnoreCase("")) {
					incorporateNaming();
				}
			}
		});
		cutButton.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(ActionEvent e) {
				removeAbstraction();
			}
		});
		abstractionsList.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(ActionEvent e) {
				goToElement(abstractionsList.getSelectedItem());
			}
		});
		concreteFormsList
			.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent e) {
					goToElement(concreteFormsList.getSelectedItem());
				}
			});
		computeButton.addActionListener(new java.awt.event.ActionListener() {
			public void actionPerformed(ActionEvent e) {
				analyzeAssociations();
			}
		});
		constraintsButton
			.addActionListener(new java.awt.event.ActionListener() {
				public void actionPerformed(ActionEvent e) {
					showConstraintsPopup();
				}
			});
		chooseGeneralizationMenu
			.addItemListener(new java.awt.event.ItemListener() {
				public void itemStateChanged(ItemEvent e) {
					linkToTheGeneralization(e);
				}
			});
		concreteEventsCheckbox
			.addItemListener(new java.awt.event.ItemListener() {
				public void itemStateChanged(ItemEvent e) {
					analyzeAssociations();
				}
			});
		generalizedEventsCheckbox
			.addItemListener(new java.awt.event.ItemListener() {
				public void itemStateChanged(ItemEvent e) {
					analyzeAssociations();
				}
			});
	} // End jbInit.

	/** Deal with choice of generalization. */
	void linkToTheGeneralization(ItemEvent click) {
		Percept focalElement, generalizedElement;
		String selectedGeneralizationName = (String) click.getItem();
		int indexOfTestElement;
		if (selectedGeneralizationName.equals(Ethno.interfaceTexts
			.getString("addAbstractionText"))) {
			// Clicked first line, the title.
			return;
		}
		int index = chooseGeneralizationMenu.getSelectedIndex();
		if (index == (indexToElement + 1)) {
			// Self reference. (The menu contains title, then element list.)
			return;
		}
		// Add the generalization.
		PerceptList elementList =
			PerceptList.getPerceptList(currentElementType);
		focalElement = (Percept) elementList.elementAt(indexToElement);
		generalizedElement =
			(Percept) elementList.elementAt(elementList
				.findPositionOfElement(selectedGeneralizationName));
		if (elementList.downwardLinks(focalElement)
			.contains(generalizedElement)
			|| elementList.upwardLinks(focalElement).contains(
				generalizedElement)) {
			// Already related.
			return;
		}
		// Remove any pre-existing generalizations that are generalizations of
		// the new generalization.
		Vector generalizationsOfNewGeneralization =
			elementList.upwardLinks(generalizedElement);
		for (int i = focalElement.implications.size() - 1; i >= 0; i--) {
			indexOfTestElement =
				elementList
					.findPositionOfElement(((Relation) focalElement.implications
						.elementAt(i)).implicated);
			Object testElement = elementList.elementAt(indexOfTestElement);
			if (generalizationsOfNewGeneralization.contains(testElement)) {
				focalElement.implications.removeElementAt(i);
			}
		}
		// Add the element as a generalization.
		focalElement.implications.addElement(new Relation(
			selectedGeneralizationName, true, false));
		// Reconstruct the generalization display.
		abstractionsList.removeAll();
		Vector abstracts = elementList.upwardLinks(focalElement);
		for (int i = 0; i < abstracts.size(); i++) {
			generalizedElement = (Percept) abstracts.elementAt(i);
			abstractionsList.add(generalizedElement.shortName);
		}
	} // End linkToGeneralization.

	/** Return to event, after saving the data on this element. */
	void returnToDeed() {
		Deed d = (Deed) Ethno.deeds.elementAt(Ethno.showDeedCard.indexToDeed);
		Ethno.showDeedCard.fetchData(d.shortName);
		Ethno.controls.generalPanel.setVisible(true);
		Ethno.controls.elementPanel.setVisible(true);
		Ethno.controls.validate();
		Ethno.theTaskNow = Ethno.SHOW_DEED;
	} // End returnToDeed.

	void removeAbstraction() {
		Percept p, y, z;
		Relation r;
		String theLine = abstractionsList.getSelectedItem();
		if (theLine == null) { return; } // Nothing selected.
		// Get the focal element and the abstract element being deleted.
		PerceptList elementList =
			PerceptList.getPerceptList(currentElementType);
		p = (Percept) elementList.elementAt(this.indexToElement);
		y =
			(Percept) elementList.elementAt(elementList
				.findPositionOfElement(theLine));
		// Delete the abstract element and all of its upward links.
		Vector abstracts = elementList.upwardLinks(y);
		abstracts.addElement(y);
		for (int i = 0; i < p.implications.size(); i++) {
			r = (Relation) p.implications.elementAt(i);
			for (int j = 0; j < abstracts.size(); j++) {
				z = (Percept) abstracts.elementAt(j);
				if (r.implicated.equals(z.shortName)) {
					p.implications.removeElementAt(i);
					i = i - 1;
					break;
				}
			}
		}
		// Reconstruct abstraction display.
		abstractionsList.removeAll();
		abstracts = elementList.upwardLinks(p);
		for (int i = 0; i < abstracts.size(); i++) {
			y = (Percept) abstracts.elementAt(i);
			abstractionsList.add(y.shortName);
		}
	} // End removeAbstraction.

	/** Show popup dialog to set constraints for association analysis. */
	void showConstraintsPopup() {
		AssociationsDialog choose =
			new AssociationsDialog((Frame) this.getParent().getParent());
		choose.setVisible(true);
	}

	public void analyzeAssociations() {
		PerceptList elementList, setOfDeeds, subResults, results, sortedResults;
		Vector deedsToAnalyze, referenceElements;
		Percept focus, p;
		Deed thisDeed;
		String testString, refString;
		String entityAssociationsText, personAssociationsText, actionAssociationsText;
		boolean aDeedToAnalyze;
		int count, repetition;
		results = new PerceptList();
		setOfDeeds = new PerceptList();
		// Get the focal element.
		elementList = PerceptList.getPerceptList(currentElementType);
		focus = (Percept) elementList.elementAt(indexToElement);
		// Use the focus as a reference, and also its implications if
		// generalizing.
		referenceElements = new Vector();
		referenceElements.addElement(focus.shortName);
		// Start writing results in the Java console.
		Ethno.reportPage.results.append(
			"\n\n" +
			Ethno.interfaceTexts.getString("reportTitleText")
			+ focus.shortName + "\n");
		if (generalizeCheckbox.getState()) {
			for (int i = 0; i < concreteFormsList.getItemCount(); i++) {
				referenceElements.addElement(concreteFormsList.getItem(i));
				Ethno.reportPage.results.append(concreteFormsList.getItem(i) + "\n");
			}
		}
		// Print the constraints regarding focal element in console.
		for (int number = 0; number < 8; number++) {
			if (wantFocusElementInFrameCategory[number]) {
				Ethno.reportPage.results.append(
					Ethno.interfaceTexts.getString("space")
					+ Ethno.eventFrameName[number]);
			}
		}
		Ethno.reportPage.results.append("\n");
		// Print the constraints regarding other element in console.
		for (int number = 0; number < 8; number++) {
			if (wantOtherElementInFrameCategory[number]) {
				Ethno.reportPage.results.append(
					Ethno.interfaceTexts.getString("space")
					+ Ethno.eventFrameName[number]);
			}
		}
		Ethno.reportPage.results.append("\n");
		// Consider all events in sequence.
		deedsToAnalyze = new Vector();
		deedsToAnalyze = Ethno.sequence;
		// Get the associations.
		for (int index = 0; index < deedsToAnalyze.size(); index++) {
			thisDeed = (Deed) deedsToAnalyze.elementAt(index);
			if (concreteEventsCheckbox.getState() == thisDeed.isGeneralization) {
				// Skip generalized deeds when only concrete deeds are shown.
				continue;
			}
			// Check whether this event fits constraints on focal element.
			aDeedToAnalyze = false;
			fitsFocalConstraints: for (int number = 0; number < 8; number++) {
				if (wantFocusElementInFrameCategory[number]) {
					for (int i = 0; i < thisDeed.eventFrame[number].size(); i++) {
						p = (Percept) thisDeed.eventFrame[number].elementAt(i);
						testString = p.shortName;
						for (int j = 0; j < referenceElements.size(); j++) {
							refString = (String) referenceElements.elementAt(j);
							if (testString.equals(refString)) {
								aDeedToAnalyze = true;
								break fitsFocalConstraints;
							}
						}
					}
				}
			}
			if (!aDeedToAnalyze) {
				// Doesn't fit constraints on focal element; go on to next deed,
				continue;
			}
			// Get the associations.
			elementList = new PerceptList();
			for (int number = 0; number < 8; number++) {
				if (wantOtherElementInFrameCategory[number]) {
					for (int i = 0; i < thisDeed.eventFrame[number].size(); i++) {
						elementList.addElement(thisDeed.eventFrame[number]
							.elementAt(i));
					}
				}
			}
			if (elementList.size() > 0) {
				// This is an event contributing to results.
				setOfDeeds.addElement(thisDeed);
			} else {
				continue; // Go on to next event.
			}
			// If generalizing, reduce to most abstract elements.
			if (generalizeCheckbox.getState()) {
				for (int i = 0; i < elementList.size(); i++) {
					p = (Percept) elementList.elementAt(i);
					Vector tempVector = new Vector();
					if (Ethno.entities.contains(p)) {
						tempVector = Ethno.entities.upwardLinks(p);
					} else if (Ethno.people.contains(p)) {
						tempVector = Ethno.people.upwardLinks(p);
					} else {
						tempVector = Ethno.actions.upwardLinks(p);
					}
					if (tempVector.size() > 0) {
						// Remove the source percept from results.
						while (elementList.removeElement(p))
							;
						// Add the more abstract elements.
						for (int j = 0; j < tempVector.size(); j++) {
							elementList.addElement(tempVector.elementAt(j));
						}
						i = i - 1;
					}
				}
			}
			// Eliminate repeats within this deed.
			subResults = new PerceptList();
			while (!elementList.isEmpty()) {
				p = (Percept) elementList.elementAt(0);
				subResults.addElement(p);
				while (elementList.removeElement(p))
					;
			}
			// Record the results for this occurrence of thisDeed.
			for (int j = 0; j < subResults.size(); j++) {
				results.addElement(subResults.elementAt(j));
			}
		} // Done indexing through containingEvents.
			// Clear the output boxes.
		reportsPanel.invalidate();
		containingEvents.removeAll();
		entityAssociations.removeAll();
		personAssociations.removeAll();
		actionAssociations.removeAll();
		// Initialize the console printout strings.
		entityAssociationsText =
			Ethno.interfaceTexts.getString("entityAssociationsLabelText")
				+ Ethno.interfaceTexts.getString("newLine");
		personAssociationsText =
			Ethno.interfaceTexts.getString("personAssociationsLabelText")
				+ Ethno.interfaceTexts.getString("newLine");
		actionAssociationsText =
			Ethno.interfaceTexts.getString("actionAssociationsLabelText")
				+ Ethno.interfaceTexts.getString("newLine");
		Ethno.reportPage.results.append("\n");
		// Show the relevant events.
		for (int i = 0; i < setOfDeeds.size(); i++) {
			thisDeed = (Deed) setOfDeeds.elementAt(i);
			containingEvents.add(thisDeed.shortName);
		}
		// Sort the element results alphabetically.
		sortedResults = results.sortElementNames();
		// Display each type with a count of the number of tokens.
		for (int newType = 0; newType < sortedResults.size(); newType++) {
			// Count tokens.
			count = 0;
			for (repetition = newType; repetition < sortedResults.size(); repetition++) {
				if (sortedResults.elementAt(repetition) == sortedResults
					.elementAt(newType)) {
					count = count + 1; // This line is a repetition.
				} else {
					// This line is a new type; set up to start here next in the
					// newType loop.
					repetition = repetition - 1;
					break;
				}
			}
			// Put the result into the proper display box, and string for
			// console printout.
			p = (Percept) sortedResults.elementAt(newType);
			if (Ethno.entities.contains(p)) {
				this.entityAssociations.add(Ethno.format0_99(count) + " "
					+ p.shortName);
				entityAssociationsText =
					entityAssociationsText + Ethno.format0_99(count) + " "
						+ p.shortName + '\n';
			} else if (Ethno.people.contains(p)) {
				this.personAssociations.add(Ethno.format0_99(count) + " "
					+ p.shortName);
				personAssociationsText =
					personAssociationsText + Ethno.format0_99(count) + " "
						+ p.shortName + '\n';
			} else {
				// This will show non-actions in the action list if duplicate
				// percepts are not incorporated as exactly equal to first
				// instance.
				this.actionAssociations.add(Ethno.format0_99(count) + " "
					+ p.shortName);
				actionAssociationsText =
					actionAssociationsText + Ethno.format0_99(count) + " "
						+ p.shortName + '\n';
			}
			newType = repetition;
		}
		Ethno.reportPage.results.append(
			actionAssociationsText + "\n"
			+ entityAssociationsText + "\n"
			+ personAssociationsText + "\n");
		reportsPanel.validate();
	} // End analyzeAssociations.

	public void rebuildElementAbstractor(PerceptList elements) {
		// Rebuild popup menu for choosing abstractions.
		Percept x;
		chooseGeneralizationMenu.invalidate();
		abstractionArea.invalidate();
		chooseGeneralizationMenu.removeAll();
		chooseGeneralizationMenu.addItem(Ethno.interfaceTexts
			.getString("addAbstractionText"));
		for (int i = 0; i < elements.size(); i++) {
			x = (Percept) elements.elementAt(i);
			chooseGeneralizationMenu.addItem(x.shortName);
		}
		abstractionArea.validate();
	} // End rebuildElementAbstractor.

	/* Fill out the form for the percept that the user selected. */
	void fetchPerceptData(String theName, PerceptList elementList) {
		Percept x, y;
		boolean wantConcreteDeeds = true;
		Vector eventsContainingThePercept, abstracts, concretes;
		// Get the element and remember its index number.
		if (elementList.size() == 0) {
			// New element yet to be specified.
			indexToElement = -1;
			return;
		}
		if (!theName.equals("")) {
			for (indexToElement = 0; indexToElement < elementList.size(); indexToElement++) {
				if (theName.equals(((Percept) elementList
					.elementAt(indexToElement)).shortName)) {
					break;
				}
			}
		}
		this.nameTextBox.setText(theName);
		// Add implications.
		abstractionsList.removeAll();
		x = (Percept) elementList.elementAt(indexToElement);
		abstracts = elementList.upwardLinks(x);
		for (int i = 0; i < abstracts.size(); i++) {
			y = (Percept) abstracts.elementAt(i);
			abstractionsList.add(y.shortName);
		}
		// Show concrete forms.
		concreteFormsList.removeAll();
		concretes = elementList.downwardLinks(x);
		for (int i = 0; i < concretes.size(); i++) {
			y = (Percept) concretes.elementAt(i);
			concreteFormsList.add(y.shortName);
		}
		// Show events containing the element.
		containingEvents.removeAll();
		eventsContainingThePercept =
			Ethno.sequence.deedsContaining(x, wantConcreteDeeds);
		for (int i = 0; i < eventsContainingThePercept.size(); i++) {
			y = (Percept) eventsContainingThePercept.elementAt(i);
			containingEvents.add(y.shortName);
		}
	} // End fetchData.

	void setCurrentElementType(int newCurrentElementType) {
		// Called from ControlMenus, or ImportExport.
		currentElementType = newCurrentElementType;
	} // End setCurrentElementType.

	void incorporateNaming() {
		Ethno.controls.incorporateDeedOrPerceptChanges();
		rebuildElementAbstractor(PerceptList.getPerceptList(currentElementType));
		nameTextBox.transferFocus();
	} // End incorporateNaming.

	void goToElement(String theName) {
//		this.chooseGeneralizationMenu.select(0);
		Ethno.controls.incorporateDeedOrPerceptChanges();
		fetchPerceptData(theName,
			PerceptList.getPerceptList(currentElementType));
	} // End goToElement.

}